/* ============================================================
 * File  : diaporama.cpp
 * Author: Stephane Gibault
 * Date  : Sun Feb 4 2007
 * Description :
 *
 *
 *  (C) 2007 by Stephane Gibault
 *
 * This program is free software; you can redistribute it
 * and/or modify it under the terms of the GNU General
 * Public License as published by the Free Software Foundation;
 * either version 2, or (at your option)
 * any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * ============================================================ */

#include <QtGui>
#include "mainfrm.h"

void mainfrm::f_valide_new_projet_slideshow()
{
    if ( line_path_projet->text() != "" )
    {
            f_scale_project();

            // *** CREATION DE LA PREMIERE DIAPOSITIVE ***
            nbre_diapos = 1;
            QImage wl_pix1(50,50,QImage::Format_ARGB32_Premultiplied);
            QPainter p;
            p.begin(&wl_pix1);
            p.setBrush(QColor(0,0,0));
            p.drawRect(0,0,50,50);
            p.end();

            diapos_th *newdiapo = new diapos_th(timeline_diapo);
            newdiapo->setGeometry( 0, 0, 50, 50 );
            newdiapo->draw_image = wl_pix1;
            newdiapo->is_edit = 1;
            newdiapo->is_first = 1;
            newdiapo->show();

            num_current_diapo = 0;
            hdl_current_diapo = newdiapo;
            table_hdl_diapo[0] = newdiapo;

            connect(newdiapo, SIGNAL(select_diapoth(diapos_th*) ),this, SLOT(f_select_diapos_th(diapos_th*)));
            connect(newdiapo, SIGNAL(delete_diapoth(diapos_th*) ),this, SLOT(f_delete_diaposth(diapos_th*)));
            connect(newdiapo, SIGNAL(dupliquer_diapoth(diapos_th*) ),this, SLOT(f_dupliquer_diaposth(diapos_th*)));
            connect(newdiapo, SIGNAL(enter_diath(diapos_th*) ),this, SLOT(f_enter_diath(diapos_th*)));
            connect(newdiapo, SIGNAL(leave_diath(diapos_th*) ),this, SLOT(f_leave_diath(diapos_th*)));

            timeline_diapo->repaint();

            pntmygl->length_diapo = screen_timeline->length_diapo;

            frame_smile->raise();
    }
    else
    {
            QMessageBox::information(this, name_application, tr("Vous devez choisir un dossier pour les fichiers de travail"));
    }
}

void mainfrm::f_scale_project()
{
    if ( line_path_projet->text() != "" )
    {
            // *** DEMARRAGE D'UN NOUVEAU PROJET ***
            if ( combo_format_dvd->currentIndex() == 0 )
            {
                    dvdxsize = 720;
                    dvdysize = 576;
                    dvd_standard = "pal";
                    dvd_format = "4/3";
                    wg_fps = "25";
                    wg_fps_int = 25;
            }
            else
            {
                    if ( combo_format_dvd->currentIndex() == 1 )
                    {
                            dvdxsize = 1024;
                            dvdysize = 576;
                            dvd_standard = "pal";
                            dvd_format = "16/9";
                            wg_fps = "25";
                            wg_fps_int = 25;
                    }
                    else
                    {
                            if ( combo_format_dvd->currentIndex() == 2 )
                            {
                                    dvdxsize = 720;
                                    dvdysize = 480;
                                    dvd_standard = "ntsc";
                                    dvd_format = "4/3";
                                    wg_fps = "30000/1001";
                                    wg_fps_int = 29.97;
                            }
                            else
                            {
                                    dvdxsize = 1024;
                                    dvdysize = 480;
                                    dvd_standard = "ntsc";
                                    dvd_format = "16/9";
                                    wg_fps = "30000/1001";
                                    wg_fps_int = 29.97;
                            }
                    }
            }

            //qDebug() << dvdxsize << " " << dvdysize;

            QFrame *frame_ed3d = new QFrame(frame_smile);
            frame_ed3d->show();

            hdl_fr3d = frame_ed3d;

            Tetrahedron *mygl = new Tetrahedron(frame_ed3d, cb_dr->checkState(), cb_aa->checkState());
            pntmygl = mygl;
            pntmygl->resize(dvdxsize,dvdysize);
            pntmygl->show();

            if ( pntmygl->format().sampleBuffers() == true )
            {
                bt_switch_quality->setEnabled(true);
                pntmygl->is_sample_layer = 1;

                if ( cb_aa->checkState() == 2 )
                {
                    bt_switch_quality->setChecked(true);
                }
                //pntmygl->setFormat(QGLFormat(QGL::NoSampleBuffers));
            }
            else
            {
                if ( cb_aa->isChecked() == true )
                {
                    pntmygl->setFormat(QGLFormat(QGL::NoSampleBuffers));
                }
                pntmygl->is_sample_layer = 0;
                bt_switch_quality->setDisabled(true);
            }

            connect(pntmygl, SIGNAL(dia_select(int)),this, SLOT(f_display_mark_on_timeline(int)));
            connect(pntmygl, SIGNAL(dia_of_preview(QString)),this, SLOT(f_open_ipreview(QString)));
            connect(pntmygl, SIGNAL(hide_preview()),this, SLOT(f_hide_preview()));
            connect(pntmygl, SIGNAL(update_preview()),this, SLOT(f_update_diapoth()));
            connect(pntmygl, SIGNAL(move_start()),this, SLOT(f_move_start()));
            connect(pntmygl, SIGNAL(load_back()),this, SLOT(f_load_back()));
            connect(pntmygl, SIGNAL(update_coo()),this, SLOT(f_update_coo()));
            connect(pntmygl, SIGNAL(change_length(int)),this, SLOT(f_change_length_diapo_from_tetra(int)));
            connect(pntmygl, SIGNAL(add_diapo()),this, SLOT(f_add_diapo_signal()));
            connect(pntmygl, SIGNAL(update_diapo()),this, SLOT(f_update_diapo_signal()));
            connect(pntmygl, SIGNAL(s_delete_diapo(int)),this, SLOT(f_s_delete_diapo(int)));
            connect(pntmygl, SIGNAL(s_edit_image()),this, SLOT(f_s_edit_image()));
            connect(bt_smile_img_bck, SIGNAL(clicked()), pntmygl, SLOT(f_load_background_1()));

            connect(pntmygl, SIGNAL(s_d_f_custo_mask()),this, SLOT(f_s_d_f_custo_mask()));

            connect(screen_timeline, SIGNAL(follow(int)),pntmygl, SLOT(f_follow_timeline(int)));

            connect(sl_esp_ana, SIGNAL(valueChanged(int)),pntmygl, SLOT(f_sl_esp_ana(int)));
            connect(check_anaglyph,SIGNAL(stateChanged(int)),pntmygl,SLOT(f_check_anaglyph(int)));
            connect(check_motion_blur,SIGNAL(stateChanged(int)),pntmygl,SLOT(f_check_motion_blur(int)));
            connect(check_fog,SIGNAL(stateChanged(int)),pntmygl,SLOT(f_check_fog(int)));

            connect(combo_od, SIGNAL(currentIndexChanged(int)),pntmygl, SLOT(f_combo_od_changed(int)));
            connect(combo_og, SIGNAL(currentIndexChanged(int)),pntmygl, SLOT(f_combo_og_changed(int)));

            connect(check_reflet,SIGNAL(stateChanged(int)),pntmygl,SLOT(f_put_reflect(int)));

            connect(sl_sca_diapo, SIGNAL(valueChanged(int)),pntmygl, SLOT(f_sl_sca_diapo(int)));

            connect(linxtxtslide, SIGNAL(textChanged(QString)), pntmygl, SLOT(f_txt_changed(QString)));
            connect(font_slidetxt,SIGNAL(currentFontChanged(QFont)),pntmygl,SLOT(f_font_slidetxt(QFont)));

            connect(frame_th_ani_smile, SIGNAL(itemDoubleClicked ( QListWidgetItem* )),pntmygl, SLOT(f_load_object(QListWidgetItem*)));
            connect(frame_th_ani_smile, SIGNAL(itemClicked ( QListWidgetItem * )),this, SLOT(f_select_item_object(QListWidgetItem *)));
            connect(frame_th_ani_smile, SIGNAL(affhide_anim ()),this, SLOT(f_affhide_anim()));

            connect(bt_bold_txtslide,SIGNAL(clicked()),pntmygl,SLOT(f_bt_bold_txtslide()));
            connect(bt_italic_txtslide,SIGNAL(clicked()),pntmygl,SLOT(f_bt_italic_txtslide()));
            connect(bt_underline_txtslide,SIGNAL(clicked()),pntmygl,SLOT(f_bt_underline_txtslide()));

            connect(pbgz,SIGNAL(clicked()),pntmygl,SLOT(f_change_tool_grab_fi()));
            connect(pbrx,SIGNAL(clicked()),pntmygl,SLOT(f_change_tool_rotate_x_fi()));
            connect(pbry,SIGNAL(clicked()),pntmygl,SLOT(f_change_tool_rotate_y_fi()));
            connect(pbrz,SIGNAL(clicked()),pntmygl,SLOT(f_change_tool_rotate_z_fi()));
            connect(pbrl,SIGNAL(clicked()),pntmygl,SLOT(f_change_tool_rotate_l_fi()));
            connect(pntmygl, SIGNAL(tool_change(int)),this, SLOT(f_tool_change(int)));

            /*connect(bt_grabzoom, SIGNAL(clicked()),pntmygl, SLOT(f_change_tool_grab()));
            connect(bt_rotate_x, SIGNAL(clicked()),pntmygl, SLOT(f_change_tool_rotate_x()));
            connect(bt_rotate_y, SIGNAL(clicked()),pntmygl, SLOT(f_change_tool_rotate_y()));
            connect(bt_rotate_z, SIGNAL(clicked()),pntmygl, SLOT(f_change_tool_rotate_z()));*/

            path_project = line_path_projet->text();
            path_always_save = "";
            player_isplaying = false;

            // *** INITIALISATIONS ***
            pntmygl->f_init_tabcoo();
            pntmygl->f_init_tabtex();
            lst_calques->clear();
            screen_timeline->f_init_pos();
            pntmygl->nombre_diapos = 0;
            timeline_diapo->max_diapo = 1;
            timeline_diapo->tab_duration[0] = spin_length_diapo->value();
            isrendering = 0;
            scroll_timeline_smile->setMaximum(0);
            scroll_timeline_smile->setValue(0);
            nbre_audio_track = 0;
            timeline_diapo->nbre_audio_track = nbre_audio_track;
            myeffect_global->setOpacity(0.0);

            // *** RESIZE DE LA FENETRE ***
            frame_new_proj->hide();
            frame_top_tool->hide();
            smenuBar->show();

            this->setWindowTitle(tr("2ManDVD - Creation de diaporamas"));
            this->setMinimumSize(dvdxsize+frame_pro->width(),dvdysize+180);//+smenuBar->height());
            this->setMaximumSize(dvdxsize+frame_pro->width(),dvdysize+180); //+smenuBar->height());
            this->setGeometry((QApplication::desktop()->screenGeometry(0).width()-(dvdxsize+frame_pro->width()))/2,(QApplication::desktop()->screenGeometry(0).height()-(dvdysize+180))/2,dvdxsize+frame_pro->width(),dvdysize+180);
            //this->setGeometry(this->geometry().x(),this->geometry().y(),dvdxsize+frame_pro->width(),dvdysize+180);
            //qDebug() << "SCREEN = " << QApplication::desktop()->screenGeometry(0).width();
            //qDebug() << dvdxsize << " " << frame_pro->width() << " " << this->width() << " " << this->height() << " " << dvdxsize+frame_pro->width();

            frame_render_smile->hide();

            smenuBar->setEnabled(true);
            menuEdition->setEnabled(true);
            actionCopier_le_bouton->setDisabled(true);
            actionColler_le_bouton->setDisabled(true);
            actionCapturer_une_image_du_menu->setEnabled(true);
            actionPreferences->setEnabled(true);

            actionAfficher_cacher_les_coordonn_es->setEnabled(true);
            actionAfficher_cacher_les_r_gles->setDisabled(true);
            actionAfficher_cacher_les_zones_de_s_curit->setDisabled(true);
            actionAfficher_cacher_les_contours->setDisabled(true);
            actionArborescence_du_projet->setDisabled(true);

            menuInsertion->setEnabled(true);
            actionAjouter_un_bouton->setDisabled(true);
            actionAjouter_plusieurs_boutons->setDisabled(true);
            actionAjouter_une_zone_de_texte->setDisabled(true);
            actionDiaporama_automatique->setEnabled(true);
            actionAjouter_une_diapositive->setEnabled(true);
            menuMenu->setDisabled(true);
            menuMenu->hide();
            menuG_n_ration->setEnabled(true);
            actionG_n_rer_le_DVD->setEnabled(true);
            actionGraver_le_DVD->setDisabled(true);
            actionGenerer_l_image_ISO_du_DVD->setDisabled(true);
            actionRevoir_la_derniere_generation->setDisabled(true);
            actionZone_du_DVD->setDisabled(true);
            menuA_propos->setEnabled(true);

            actionOuvrir->setEnabled(true);
            actionEnregistrer->setEnabled(true);
            actionEnregistrer_2->setDisabled(true);

            dial_smile_light->setDisabled(true);
            dial_smile_contrast->setDisabled(true);
            slider_opa_slide->setDisabled(true);
            slider_blur_img->setDisabled(true);
            check_reflet->setDisabled(true);
            sl_sca_diapo->setDisabled(true);

            dial_smile_light->setDisabled(true);
            dial_smile_contrast->setDisabled(true);
            slider_opa_slide->setDisabled(true);
            slider_blur_img->setDisabled(true);
            check_reflet->setDisabled(true);
            sl_sca_diapo->setDisabled(true);
            frame_th_msk_smile->setDisabled(true);

            linxtxtslide->setDisabled(true);
            wheel_txt_col_slide->setDisabled(true);

            frame_smile->setGeometry(0,0,this->width(),this->height());
            frame_smile->show();
            frame_smile->raise();
            frame_ed3d->setGeometry(0,0,dvdxsize,dvdysize);
            frame_msk_ed3d->setGeometry(0,0,dvdxsize,dvdysize);
            frame_msk_ed3d->hide();
            frame_holy->hide();
            frame_holy_param->hide();
            frame_holy->setGeometry((this->width()-frame_holy->width())/2,(this->height()-frame_holy->height())/2,frame_holy->width(),frame_holy->height());
            frame_holy_param->setGeometry((this->width()-frame_holy_param->width())/2,(this->height()-frame_holy_param->height())/2,frame_holy_param->width(),frame_holy_param->height());

            //pntmygl->resizeGL(dvdxsize,dvdysize);

            frame_bottom_slide->setGeometry(0,this->height()-180,this->width(),50);
            screen_timeline->setGeometry((pntmygl->width()-700)/2,5,700,40);
            frame_toolslide->setGeometry(dvdxsize,0,this->width()-dvdxsize,this->height()-170);
            //frame_tools_3d->setGeometry(dvdxsize+((this->width()-(frame_tools_3d->width()+dvdxsize+20))/2),0,frame_tools_3d->width(),frame_tools_3d->height());

            frame_tools_3d->setGeometry(frame_toolslide->geometry().x()+((frame_toolslide->width()-frame_tools_3d->width())/2),0,frame_tools_3d->width(),frame_tools_3d->height());

            frame_topbt_smile->setGeometry((frame_toolslide->width()-frame_topbt_smile->width())/2,frame_toolslide->height()-(frame_topbt_smile->height()+10),frame_topbt_smile->width(),frame_topbt_smile->height());

            tab_smile->setGeometry(10,10,frame_toolslide->width()-20,frame_topbt_smile->geometry().y()-20);
            frame_pro_smile->setGeometry(0,0,frame_toolslide->width(),frame_topbt_smile->geometry().y());

            frame_choose_encode->setGeometry((this->width()-frame_choose_encode->width())/2,(this->height()-frame_choose_encode->height())/2,frame_choose_encode->width(),frame_choose_encode->height());

            wheel_back_slide->setGeometry((frame_pro_smile->width()-wheel_back_slide->width())/2,wheel_back_slide->geometry().y(),wheel_back_slide->width(),wheel_back_slide->height());
            label_56->setGeometry(10,label_56->geometry().y(),frame_pro_smile->width()-20,label_56->height());

            sl_esp_ana->setGeometry(sl_esp_ana->geometry().x(),sl_esp_ana->geometry().y(),tb_diapositive->width()-(10+sl_esp_ana->geometry().x()),sl_esp_ana->height());
            combo_od->setGeometry(combo_od->geometry().x(),combo_od->geometry().y(),tb_diapositive->width()-(10+sl_esp_ana->geometry().x()),sl_esp_ana->height());
            combo_og->setGeometry(combo_og->geometry().x(),combo_og->geometry().y(),tb_diapositive->width()-(10+sl_esp_ana->geometry().x()),sl_esp_ana->height());

            slider_opa_slide->setGeometry(10,slider_opa_slide->geometry().y(),tb_diapositive->width()-20,slider_opa_slide->height());
            slider_blur_img->setGeometry(10,slider_blur_img->geometry().y(),tb_diapositive->width()-20,slider_blur_img->height());
            sl_sca_diapo->setGeometry(10,sl_sca_diapo->geometry().y(),tb_diapositive->width()-20,sl_sca_diapo->height());

            frame_coorsmile->setGeometry(0,frame_bottom_slide->geometry().y(),dvdxsize,0);

            tb_diapositive->setGeometry(10,10,frame_pro_smile->width()-20,330);
            frame_calques->setGeometry(0,tb_diapositive->height()+15,frame_pro_smile->width(),frame_pro_smile->height()-340);
            lst_calques->setGeometry(40,10,frame_calques->width()-50,frame_calques->height()-20);

            frame_thm_smile->setGeometry(0,frame_toolslide->height(),frame_toolslide->width(),frame_topbt_smile->geometry().y());
            frame_th_msk_smile->setGeometry(10,10,tab_smile->width()-20,tab_smile->height()-50);

            bt_smile_img_bck->setGeometry((frame_pro_smile->width()-bt_smile_img_bck->width())/2,bt_smile_img_bck->geometry().y(),bt_smile_img_bck->width(),bt_smile_img_bck->height());
            //lst_trans_smile->setGeometry((frame_pro_smile->width()-lst_trans_smile->width())/2,lst_trans_smile->geometry().y(),lst_trans_smile->width(),lst_trans_smile->height());

            frame_support_th3d->setGeometry(10,10,tab_smile->width()-20,tab_smile->height()-50);
            frame_th_ani_smile->setGeometry(10,10,tab_smile->width()-20,tab_smile->height()-50);
            frame_lcd_position->setGeometry(screen_timeline->geometry().x()+screen_timeline->width()+5,(frame_bottom_slide->height()-frame_lcd_position->height())/2,frame_lcd_position->width(),frame_lcd_position->height());
            frame_preview_image->setGeometry(this->width()-(frame_preview_image->width()+15),this->height()-(frame_preview_image->height()+15),frame_preview_image->width(),frame_preview_image->height());
            frame_support_timeline_diapo->setGeometry(0,this->height()-130,this->width(),130);
            frame_support_timeline->setGeometry(40,0,this->width()-40,85);
            scroll_timeline_smile->setGeometry(40,90,this->width()-42,16);
            scroll_timeline_smile->raise();

            timeline_diapo->setGeometry(0,0,this->width()-20,85);


            frame_preferences->setGeometry((this->width()-frame_preferences->width())/2,(this->height()-frame_preferences->height())/2,frame_preferences->width(),frame_preferences->height());
            tabprodia->setGeometry(0,0,page->width(),page->height());

            //frame_support_th3d->setGeometry(10,10,tab_slide_opt->width()-20,tab_slide_opt->height()-60);
            //frame_support_timeline_diapo->raise();
            //frame_tools_3d->raise();
            frame_bottom_slide->raise();
            frame_lcd_position->raise();

            mask_interface->setGeometry(0,0,this->width(),this->height());
            mask_interface->hide();
            frame_apropos->setGeometry((this->width()-frame_apropos->width())/2,(this->height()-frame_apropos->height())/2,frame_apropos->width(),frame_apropos->height());
        }
}

void mainfrm::f_s_d_f_custo_mask()
{
    QPixmap wl_pix_001(preview_customize->width(),preview_customize->height());
    wg_pix_002.load(":/Interface/Interface/back_transparent.png");
    //QPixmap wlpixmap = QPixmap::grabWidget(background_menu);
    //wg_pix_002 = wlpixmap.copy(hdl_current_menu->menu_x,hdl_current_menu->menu_y,hdl_current_menu->menu_width,hdl_current_menu->menu_height);
    wg_pix_002 = wg_pix_002.scaled(preview_customize->width(),preview_customize->height());

    QStringList wl_explode = pntmygl->tab_diapo[pntmygl->num_select][3].split("%*",QString::KeepEmptyParts);

    if ( wg_pix_001.load(qApp->applicationDirPath() + "/Bibliotheque/Masks/2t_" + wl_explode.at(0) + ".png") == true )
    {
        wg_pix_003 = wg_pix_001.scaledToHeight(preview_customize->height(), Qt::SmoothTransformation);

        must_update = 0;
        slider_custo_red->setValue(wl_explode.at(1).toInt());
        slider_custo_green->setValue(wl_explode.at(2).toInt());
        slider_custo_blue->setValue(wl_explode.at(3).toInt());
        slider_custo_opacity->setValue(wl_explode.at(4).toInt());
        must_update = 1;

        thread_img->rouge = slider_custo_red->value();
        thread_img->vert = slider_custo_green->value();
        thread_img->bleu = slider_custo_blue->value();
        thread_img->opacity = slider_custo_opacity->value();

        thread_img->wlimg = wg_pix_003.toImage().convertToFormat(QImage::Format_ARGB32, Qt::AutoColor);
        thread_img->run();
        
        QPainter p;
        p.begin(&wl_pix_001);
        p.drawPixmap(0,0,-1,-1,wg_pix_002);
        p.drawPixmap((wl_pix_001.width()-wg_pix_003.width())/2,(wl_pix_001.height()-wg_pix_003.height())/2,-1,-1,QPixmap::fromImage(thread_img->wlimg));
        p.end();

        preview_customize->setPixmap(wl_pix_001);

        QPixmap wl_pix_002(this->width(),this->height());
        wl_pix_002.fill(QColor(0,0,0,240));
        mask_interface->setPixmap(wl_pix_002);

        smenuBar->setDisabled(true);

        mask_interface->show();
        mask_interface->raise();

        frame_customize->setGeometry((this->width()-frame_customize->width())/2,(this->height()-frame_customize->height())/2,frame_customize->width(),frame_customize->height());
        frame_customize->show();
        frame_customize->raise();
    }
    else
    {
        QMessageBox::information(this, name_application, tr("Ce mask ne peut comporte pas d'elements customisables"));
    }
}

void mainfrm::f_switch_quality()
{
    if ( bt_switch_quality->isChecked() == true )
    {
        pntmygl->quality_high();
        pntmygl->updateGL();
    }
    else
    {
        pntmygl->quality_low();
        pntmygl->updateGL();
    }
}

void mainfrm::f_update_coo()
{
    must_update = 0;
    slider_opa_slide->setValue(pntmygl->tab_coo[pntmygl->num_select][9]);
    slider_blur_img->setValue(pntmygl->tab_coo[pntmygl->num_select][10]);
    must_update = 1;

    txt_px->setText(QString::number(pntmygl->tab_coo[pntmygl->num_select][0]));
    txt_py->setText(QString::number(pntmygl->tab_coo[pntmygl->num_select][1]));
    txt_pz->setText(QString::number(pntmygl->tab_coo[pntmygl->num_select][2]));

    txt_rx->setText(QString::number(pntmygl->tab_coo[pntmygl->num_select][5]));
    txt_ry->setText(QString::number(pntmygl->tab_coo[pntmygl->num_select][6]));
    txt_rz->setText(QString::number(pntmygl->tab_coo[pntmygl->num_select][7]));
}

void mainfrm::f_hide_preview()
{
    frame_preview_image->hide();
}

void mainfrm::f_mark_pos()
{
    pntmygl->f_mark_pos(screen_timeline->pos_x,10,slider_opa_slide->value(),slider_blur_img->value());
}

void mainfrm::f_deplace_keyframe()
{
    if ( pntmygl->num_select > 0 )
    {
        int j = 0;
        int ok = 0;
        QStringList wl_exp;
        QStringList wl_exp_2;

        while ( j < 20 && pntmygl->tab_coo_timeline[pntmygl->num_select][j] != "" && ok == 0 ) // *** RECHERCHE COORD POINT DEPART ***
        {
            wl_exp = pntmygl->tab_coo_timeline[pntmygl->num_select][j].split(":",QString::SkipEmptyParts);
            if ( wl_exp.at(0).toInt() == screen_timeline->save_point )
            {
                ok = 1;
            }
            else
            {
                j++;
            }
        }

        QString wl_save = pntmygl->tab_coo_timeline[pntmygl->num_select][j];
        int i = j;

        /*while ( screen_timeline->tab_mark[j+1][0] != "" && j < 20 )
        {
            screen_timeline->tab_mark[j][0] = screen_timeline->tab_mark[j+1][0];
            j++;
        }
        screen_timeline->repaint();*/

        j = i;

        while ( pntmygl->tab_coo_timeline[pntmygl->num_select][j] != "" && j < 20 ) // *** ON DEPLACE LES COORD D'APRES ***
        {
            pntmygl->tab_coo_timeline[pntmygl->num_select][j] = pntmygl->tab_coo_timeline[pntmygl->num_select][j+1];
            j++;
        }

        j = 0;
        ok = 0;

        while ( j < 20 && pntmygl->tab_coo_timeline[pntmygl->num_select][j] != "" && ok == 0 )
        {
            wl_exp_2 = pntmygl->tab_coo_timeline[pntmygl->num_select][j].split(":",QString::SkipEmptyParts);

            if ( wl_exp_2.at(0).toInt() >= screen_timeline->new_position ) //screen_timeline->save_point )
            {
                ok = 1;
            }
            else
            {
                j++;
            }
        }

        wl_exp = wl_save.split(":",QString::SkipEmptyParts);
        QString wl_save_to = QString::number(screen_timeline->new_position) + ":" + wl_exp.at(1) + ":" + wl_exp.at(2) + ":" + wl_exp.at(3) + ":" + wl_exp.at(4) + ":" + wl_exp.at(5) + ":" + wl_exp.at(6) + ":" + wl_exp.at(7) + ":" + wl_exp.at(8) + ":" + wl_exp.at(9);

        //qDebug() << wl_exp_2.at(0).toInt() << " " << screen_timeline->save_point;

        if ( wl_exp_2.at(0).toInt() == screen_timeline->save_point )
        {
            pntmygl->tab_coo_timeline[pntmygl->num_select][j] = wl_save_to;
        }
        else
        {
            i = j;

            while ( pntmygl->tab_coo_timeline[pntmygl->num_select][j] != "" && j < 20 )
            {
                j++;
            }

            while ( j >= i )
            {
                pntmygl->tab_coo_timeline[pntmygl->num_select][j] = pntmygl->tab_coo_timeline[pntmygl->num_select][j-1];
                j--;
            }
            pntmygl->tab_coo_timeline[pntmygl->num_select][i] = wl_save_to;
        }

        f_display_mark_on_timeline(pntmygl->num_select);
     }
    pntmygl->f_follow_timeline(screen_timeline->new_position);
}

void mainfrm::f_display_mark_on_timeline(int num_select)
{
    // *** CHARGEMENT DES POSITIONS MARQUEES DANS LA TIMELINE ***
    screen_timeline->f_init_pos();
    pntmygl->must_update = 0;

    if ( num_select > 0 )
    {
        if ( pntmygl->tab_diapo[num_select][0].mid(0,1) == "?" && pntmygl->tab_diapo[num_select][0].mid(0,2) != "?9" )
        {
            screen_timeline->is_object = 1;
        }
        else
        {
            screen_timeline->is_object = 0;
        }

        int wl_int_001 = 0;
        QStringList wl_explode;

        while ( wl_int_001 < 20 )
        {
            //qDebug() << "DMOT = " << pntmygl->tab_coo_timeline[num_select][wl_int_001];

            wl_explode = pntmygl->tab_coo_timeline[num_select][wl_int_001].split(":",QString::KeepEmptyParts);

            if ( wl_explode.count() > 2 )
            {
                screen_timeline->tab_mark[wl_int_001][0] = wl_explode.at(0);
                screen_timeline->tab_mark[wl_int_001][1] = wl_explode.at(wl_explode.count()-3);
                screen_timeline->tab_mark[wl_int_001][2] = wl_explode.at(wl_explode.count()-2);
                screen_timeline->tab_mark[wl_int_001][3] = wl_explode.at(wl_explode.count()-1);
            }
            else
            {
                screen_timeline->tab_mark[wl_int_001][0] = "";
                screen_timeline->tab_mark[wl_int_001][1] = "1";
                screen_timeline->tab_mark[wl_int_001][2] = "0";
                screen_timeline->tab_mark[wl_int_001][3] = "0";
            }
            //must_update = 0;
            //slider_opa_slide->setValue(screen_timeline->tab_mark[wl_int_001][2].toInt());
            //must_update = 1;
            wl_int_001++;
        }

        //qDebug() << "SEL= " << pntmygl->tab_diapo[num_select][0] << " " << pntmygl->tab_diapo[num_select][1] << pntmygl->tab_diapo[num_select][2] << " " << pntmygl->tab_diapo[num_select][3] << " " << pntmygl->tab_diapo[num_select][4] << " " << pntmygl->tab_diapo[num_select][5] << " " << num_select;

        screen_timeline->num_select = num_select;
        sl_sca_diapo->setValue((float)pntmygl->tab_diapo[num_select][5].toFloat()*(float)100);
        must_update = 0;
        slider_opa_slide->setValue(pntmygl->tab_coo[num_select][9]);
        slider_blur_img->setValue(pntmygl->tab_coo[num_select][10]);
        must_update = 1;

        if ( pntmygl->tab_diapo[num_select][6] == "0" )
        {
            check_reflet->setChecked(false);
        }
        else
        {
            check_reflet->setChecked(true);
        }

        if ( pntmygl->tab_diapo[num_select][0].mid(0,1) == "?" && pntmygl->tab_diapo[num_select][0].mid(0,2) != "?9" )
        {
            dial_smile_light->setDisabled(true);
            dial_smile_contrast->setDisabled(true);
            slider_opa_slide->setDisabled(true);
            slider_blur_img->setDisabled(true);
            check_reflet->setDisabled(true);
            sl_sca_diapo->setEnabled(true);
            frame_th_msk_smile->setDisabled(true);

            linxtxtslide->setDisabled(true);
            wheel_txt_col_slide->setDisabled(true);
        }
        else
        {
            if ( pntmygl->tab_diapo[num_select][0] == "NULL" )
            {
                dial_smile_light->setDisabled(true);
                dial_smile_contrast->setDisabled(true);
                slider_blur_img->setDisabled(true);
                slider_opa_slide->setEnabled(true);
                check_reflet->setEnabled(true);
                sl_sca_diapo->setEnabled(true);
                frame_th_msk_smile->setEnabled(true);
            }
            else
            {
                dial_smile_light->setEnabled(true);
                dial_smile_contrast->setEnabled(true);
                slider_opa_slide->setEnabled(true);
                slider_blur_img->setEnabled(true);
                check_reflet->setEnabled(true);
                sl_sca_diapo->setEnabled(true);
                frame_th_msk_smile->setEnabled(true);
            }

            if ( pntmygl->tab_diapo[num_select][0].mid(0,2) == "?9" )
            {
                linxtxtslide->setEnabled(true);
                wheel_txt_col_slide->setEnabled(true);

                QStringList wl_explode = pntmygl->tab_diapo[num_select][0].split("!;!",QString::KeepEmptyParts);

                pntmygl->must_update = 0;


                linxtxtslide->setText(wl_explode.at(0).mid(2,wl_explode.at(0).length()-2));


                if ( wl_explode.at(3).mid(0,1) == "1" )
                {
                    bt_bold_txtslide->setChecked(true);
                }
                else
                {
                    bt_bold_txtslide->setChecked(false);
                }

                if ( wl_explode.at(3).mid(1,1) == "1" )
                {
                    bt_italic_txtslide->setChecked(true);
                }
                else
                {
                    bt_italic_txtslide->setChecked(false);
                }

                if ( wl_explode.at(3).mid(2,1) == "1" )
                {
                    bt_underline_txtslide->setChecked(true);
                }
                else
                {
                    bt_underline_txtslide->setChecked(false);
                }

                QStringList wl_explode2 = wl_explode.at(1).split("*^*",QString::KeepEmptyParts);

                pntwheel10->setColor(wl_explode2.at(0).toInt(),wl_explode2.at(1).toInt(),wl_explode2.at(2).toInt());
                //qDebug() << wl_explode2.at(0).toInt() << " " << wl_explode2.at(1).toInt() << " " << wl_explode2.at(2).toInt() << " " << pntmygl->tab_diapo[num_select][0];

                pntmygl->must_update = 1;
            }
            else
            {
                linxtxtslide->setDisabled(true);
                wheel_txt_col_slide->setDisabled(true);

                bt_bold_txtslide->setDisabled(true);
                bt_italic_txtslide->setDisabled(true);
                bt_underline_txtslide->setDisabled(true);

                linxtxtslide->setText("");

                pntmygl->must_update = 0;
            }
        }

        //pntmygl->f_follow_timeline(screen_timeline->pos_x); // *** TODO VERIFIER SUPPRESSION ***

        lst_calques->setCurrentRow(num_select-1);
        screen_timeline->repaint();

        QStringList wl_ext1 = pntmygl->tab_diapo[num_select][4].split(":",QString::SkipEmptyParts);

        must_update = 0;
        dial_smile_light->setValue(wl_ext1.at(0).toInt());
        dial_smile_contrast->setValue(wl_ext1.at(1).toInt());
        must_update = 1;
    }
    else
    {
        screen_timeline->num_select = 0;
        dial_smile_light->setDisabled(true);
        dial_smile_contrast->setDisabled(true);
        slider_opa_slide->setDisabled(true);
        slider_blur_img->setDisabled(true);
        check_reflet->setDisabled(true);
        sl_sca_diapo->setDisabled(true);
        screen_timeline->repaint();
    }
}

void mainfrm::f_display_position_timeline(int position)
{
    QTime wl_time(0,0,0,0);
    QTime wl_time2(0,0,0,0);
    wl_time2 = wl_time.addMSecs(((float)(position-10)*((float)screen_timeline->length_diapo))/(float)(screen_timeline->width()-20)*1000);
    frame_lcd_position->position = wl_time2.toString("ss.zzz");
    frame_lcd_position->repaint();
}

void mainfrm::f_slider_opa_slide(int value)
{
    if ( must_update == 1 && pntmygl->num_select > 0 )
    {
        pntmygl->tab_coo[screen_timeline->num_select][9] = value;
        pntmygl->updateGL();
    }
}

void mainfrm::f_slider_blur_slide(int value)
{
    if ( must_update == 1 && pntmygl->num_select > 0 )
    {
        pntmygl->tab_coo[screen_timeline->num_select][10] = value;
        pntmygl->f_reload_img(screen_timeline->num_select);
        pntmygl->updateGL();
    }
}

void mainfrm::f_add_diapo()
{
    if ( nbre_diapos+1 >= 400 )
    {
        QMessageBox::information(this, name_application, tr("Nombre maximum de diapositive 400 atteint"));
        return;
    }

    pntmygl->f_save_diapo(num_current_diapo);
    screen_timeline->num_select = 0;

    lst_calques->clear();

    // *** NETTOYAGE DE L'ACCUM BUFFER ***
    pntmygl->f_netbuf();

    QImage wl_pix1(50,50,QImage::Format_ARGB32_Premultiplied);
    QPainter p;
    p.begin(&wl_pix1);
    p.setBrush(QColor(0,0,0));
    p.drawRect(0,0,50,50);
    p.end();

    hdl_current_diapo->is_edit = 0;
    hdl_current_diapo->repaint();

    pntmygl->must_update = 0;

    linxtxtslide->setText("");
    bt_bold_txtslide->setChecked(false);
    bt_italic_txtslide->setChecked(false);
    bt_underline_txtslide->setChecked(false);

    linxtxtslide->setDisabled(true);
    bt_bold_txtslide->setDisabled(true);
    bt_italic_txtslide->setDisabled(true);
    bt_underline_txtslide->setDisabled(true);

    pntmygl->must_update = 1;

    diapos_th *newdiapo = new diapos_th(timeline_diapo);

    connect(newdiapo, SIGNAL(select_diapoth(diapos_th*) ),this, SLOT(f_select_diapos_th(diapos_th*)));
    connect(newdiapo, SIGNAL(delete_diapoth(diapos_th*) ),this, SLOT(f_delete_diaposth(diapos_th*)));
    connect(newdiapo, SIGNAL(dupliquer_diapoth(diapos_th*) ),this, SLOT(f_dupliquer_diaposth(diapos_th*)));
    connect(newdiapo, SIGNAL(enter_diath(diapos_th*) ),this, SLOT(f_enter_diath(diapos_th*)));
    connect(newdiapo, SIGNAL(leave_diath(diapos_th*) ),this, SLOT(f_leave_diath(diapos_th*)));

    if ( num_current_diapo+1 >= nbre_diapos )
    {
        table_hdl_diapo[nbre_diapos] = newdiapo;
        newdiapo->setGeometry( nbre_diapos * 60, 0, 50, 50 );
        num_current_diapo = nbre_diapos;
    }
    else
    {
        int wl_i1 = num_current_diapo;
        while ( wl_i1 < nbre_diapos )
        {
            if ( wl_i1 < nbre_diapos-1 )
            {
                QPropertyAnimation *animation2 = new QPropertyAnimation(table_hdl_diapo[wl_i1], "geometry");
                animation2->setDuration(300);
                animation2->setStartValue(QRect(table_hdl_diapo[wl_i1]->geometry().x(),table_hdl_diapo[wl_i1]->geometry().y(),table_hdl_diapo[wl_i1]->width(),table_hdl_diapo[wl_i1]->height()));
                animation2->setEndValue(QRect(table_hdl_diapo[wl_i1+1]->geometry().x(),table_hdl_diapo[wl_i1+1]->geometry().y(),table_hdl_diapo[wl_i1]->width(),table_hdl_diapo[wl_i1]->height()));
                animation2->setEasingCurve(QEasingCurve::InOutCubic);
                animation2->start();
            }
            else
            {
                QPropertyAnimation *animation2 = new QPropertyAnimation(table_hdl_diapo[wl_i1], "geometry");
                animation2->setDuration(300);
                animation2->setStartValue(QRect(table_hdl_diapo[wl_i1]->geometry().x(),table_hdl_diapo[wl_i1]->geometry().y(),table_hdl_diapo[wl_i1]->width(),table_hdl_diapo[wl_i1]->height()));
                animation2->setEndValue(QRect(table_hdl_diapo[wl_i1]->geometry().x()+60,table_hdl_diapo[wl_i1]->geometry().y(),table_hdl_diapo[wl_i1]->width(),table_hdl_diapo[wl_i1]->height()));
                animation2->setEasingCurve(QEasingCurve::InOutCubic);
                animation2->start();
            }

            wl_i1++;
        }

        // *** PERMUTATION DES HANDLES ***
        //diapos_th *hdltmp;

        //QString save_diapo_tmp[45];

        //qDebug() << "DEBUG : " << num_current_diapo << " " << nbre_diapos;

        int wl_int_001 = nbre_diapos;
        int wl_int_002;
        //hdltmp = table_hdl_diapo[num_current_diapo];

        while ( wl_int_001 >= num_current_diapo )
        {
            //qDebug() << wl_int_001 << " " << num_current_diapo;
            table_hdl_diapo[wl_int_001+1] = table_hdl_diapo[wl_int_001];
            wl_int_002 = 0;
            while ( wl_int_002 < 45 )
            {
                pntmygl->tab_save_diapo[wl_int_001+1][wl_int_002] = pntmygl->tab_save_diapo[wl_int_001][wl_int_002];
                wl_int_002++;
            }
            wl_int_001--;
        }
        table_hdl_diapo[num_current_diapo] = newdiapo;

        /*wl_int_002 = 0;
        while ( wl_int_002 < 45 )
        {
            pntmygl->tab_save_diapo[num_current_diapo][wl_int_002] = "";
            wl_int_002++;
        }
        pntmygl->tab_save_diapo[num_current_diapo][0] = "$#$";*/

        newdiapo->setGeometry( num_current_diapo * 60, 0, 50, 50 );
    }
    newdiapo->draw_image = wl_pix1;
    newdiapo->is_edit = 1;
    newdiapo->show();

    //timeline_diapo->repaint();

    int wl_int_001 = 0;
    while ( wl_int_001 < 20 )
    {
        screen_timeline->tab_mark[wl_int_001][0] = "";
        screen_timeline->tab_mark[wl_int_001][1] = "";
        screen_timeline->tab_mark[wl_int_001][2] = "";
        wl_int_001++;
    }
    screen_timeline->repaint();

    hdl_current_diapo = newdiapo;

    timeline_diapo->tab_duration[nbre_diapos] = spin_length_diapo->value();
    pntmygl->back_color = "0:0:0";
    pntmygl->is_mblur = 0;
    pntmygl->is_fog = 0;
    pntmygl->wg_nb_cube = 0;
    check_motion_blur->setChecked(false);
    check_fog->setChecked(false);

    nbre_diapos++;
    timeline_diapo->max_diapo = nbre_diapos;
    timeline_diapo->num_current_diapo = num_current_diapo;
    timeline_diapo->repaint();

    if ( (nbre_diapos*70) > timeline_diapo->width() )
    {
        timeline_diapo->setGeometry(timeline_diapo->geometry().x(),0,nbre_diapos*70,timeline_diapo->height());
        scroll_timeline_smile->setMaximum(timeline_diapo->width()-frame_support_timeline->width());

        if ( myeffect_global->opacity() < 1.0 )
        {
            QPropertyAnimation *animation = new QPropertyAnimation(myeffect_global, "opacity");
            animation->setDuration(1000);
            animation->setStartValue(qreal(myeffect_global->opacity()));
            animation->setEndValue(qreal(1.0));
            animation->start();
        }
    }

    must_update = 0;
    pntmygl->str_trans = "";
    lst_trans_smile->setCurrentIndex(0);
    must_update = 1;

    pntmygl->nombre_diapos = 0;
    pntmygl->f_init_tabcoo();
    pntmygl->f_init_tabtex();

    pntmygl->num_select = 0;
    pntmygl->updateGL();

    f_recalc_length_audio();
}

void mainfrm::f_scroll_timeline_smile(int value)
{
    timeline_diapo->setGeometry(0-value,0,timeline_diapo->width(),timeline_diapo->height());
    timeline_diapo->repaint();
    if ( nbre_audio_track > 0 )
    {
        hdl_audio->repaint();
    }
}

void mainfrm::f_update_diapoth()
{
    if ( pntmygl->nombre_diapos == 0 || pntmygl->tab_diapo[1][0] == "NULL" )
    {
        hdl_current_diapo->draw_image = pntmygl->grabFrameBuffer( false ).scaled(106,106);
    }
    else
    {
        hdl_current_diapo->draw_image = pntmygl->grabFrameBuffer( false ).scaled(106,106);

        QImage wl_img;
        /*if ( pntmygl->num_select == 0 )
        {
            wl_img.load(pntmygl->tab_diapo[pntmygl->nombre_diapos][0]);
            wl_img = wl_img.scaled(106,106);
        }
        else
        {
            wl_img.load(pntmygl->tab_diapo[pntmygl->num_select][0]);
            wl_img = wl_img.scaled(106,106);
        }*/
        wl_img.load(pntmygl->tab_diapo[1][0]);
        wl_img = wl_img.scaled(106,106);
        QPainter p;
        p.begin(&hdl_current_diapo->draw_image);
        p.drawImage(0,0, wl_img, 0, 0, -1, -1 );
        p.end();
        //hdl_current_diapo->draw_image = wl_img.scaled(106,106);
    }
    hdl_current_diapo->repaint();
}

void mainfrm::f_delete_diaposth(diapos_th* hdld)
{
    int wl_int_001 = 0;
    while ( table_hdl_diapo[wl_int_001] != hdld )
    {
        wl_int_001++;
    }

    int wl_int_002 = wl_int_001;
    int wl_int_003 = 0;

    while ( wl_int_002 < nbre_diapos-1 )
    {
        table_hdl_diapo[wl_int_002] = table_hdl_diapo[wl_int_002+1];
        wl_int_003 = 0;

        while ( wl_int_003 < 45 ) //pntmygl->tab_save_diapo[wl_int_002+1][wl_int_003] != "$#$" )
        {
            pntmygl->tab_save_diapo[wl_int_002][wl_int_003] = pntmygl->tab_save_diapo[wl_int_002+1][wl_int_003];
            /*if ( wl_int_003 < 19 )
            {
                pntmygl->tab_coo_timeline[wl_int_002][wl_int_003] = pntmygl->tab_coo_timeline[wl_int_002+1][wl_int_003];
            }*/
            wl_int_003++;
        }
        /*pntmygl->tab_save_diapo[wl_int_002][wl_int_003] = pntmygl->tab_save_diapo[wl_int_002+1][wl_int_003];
        wl_int_003++;
        pntmygl->tab_save_diapo[wl_int_002][wl_int_003] = pntmygl->tab_save_diapo[wl_int_002+1][wl_int_003];
        wl_int_003++;
        pntmygl->tab_save_diapo[wl_int_002][wl_int_003] = pntmygl->tab_save_diapo[wl_int_002+1][wl_int_003];
        wl_int_003++;
        pntmygl->tab_save_diapo[wl_int_002][wl_int_003] = pntmygl->tab_save_diapo[wl_int_002+1][wl_int_003];
        wl_int_003++;
        pntmygl->tab_save_diapo[wl_int_002][wl_int_003] = pntmygl->tab_save_diapo[wl_int_002+1][wl_int_003];*/

        QPropertyAnimation *animation = new QPropertyAnimation(table_hdl_diapo[wl_int_002+1], "geometry");
        animation->setDuration(500+(50*wl_int_002));
        animation->setStartValue(QRect(table_hdl_diapo[wl_int_002+1]->geometry().x(),table_hdl_diapo[wl_int_002+1]->geometry().y(),table_hdl_diapo[wl_int_002+1]->width(),table_hdl_diapo[wl_int_002+1]->height()));
        animation->setEndValue(QRect(table_hdl_diapo[wl_int_002+1]->geometry().x()-60,table_hdl_diapo[wl_int_002+1]->geometry().y(),table_hdl_diapo[wl_int_002+1]->width(),table_hdl_diapo[wl_int_002+1]->height()));
        animation->setEasingCurve(QEasingCurve::InOutCubic);
        animation->start();

        wl_int_002++;
    }

    timeline_diapo->tab_duration[nbre_diapos] = 0;
    nbre_diapos--;
    timeline_diapo->max_diapo = nbre_diapos;
    timeline_diapo->repaint();

    if ( (nbre_diapos*70) > timeline_diapo->width() )
    {
        timeline_diapo->setGeometry(timeline_diapo->geometry().x(),0,nbre_diapos*70,timeline_diapo->height());
        scroll_timeline_smile->setMaximum(timeline_diapo->width()-frame_support_timeline->width());

        if ( myeffect_global->opacity() < 1.0 )
        {
            QPropertyAnimation *animation_2 = new QPropertyAnimation(myeffect_global, "opacity");
            animation_2->setDuration(1000);
            animation_2->setStartValue(qreal(myeffect_global->opacity()));
            animation_2->setEndValue(qreal(0.0));
            animation_2->start();
        }
    }
    else
    {
        if ( nbre_diapos*70 <= frame_support_timeline->width() && myeffect_global->opacity() > 0 )
        {
            timeline_diapo->setGeometry(timeline_diapo->geometry().x(),0,frame_support_timeline->width(),timeline_diapo->height());
            scroll_timeline_smile->setMaximum(frame_support_timeline->width());
            scroll_timeline_smile->setValue(0);

            QPropertyAnimation *animation_2 = new QPropertyAnimation(myeffect_global, "opacity");
            animation_2->setDuration(1000);
            animation_2->setStartValue(qreal(myeffect_global->opacity()));
            animation_2->setEndValue(qreal(0.0));
            animation_2->start();
        }
    }

    if ( wl_int_002 < nbre_diapos )
    {
        num_current_diapo = wl_int_002;
        f_load_diapo(wl_int_002);
        table_hdl_diapo[wl_int_002]->is_edit = 1;
        hdl_current_diapo = table_hdl_diapo[wl_int_002];
        spin_length_diapo->setValue(pntmygl->length_diapo);
        pntmygl->f_follow_timeline(10);
    }
    else
    {
        num_current_diapo = wl_int_002-1;
        f_load_diapo(wl_int_002-1);
        table_hdl_diapo[wl_int_002-1]->is_edit = 1;
        hdl_current_diapo = table_hdl_diapo[wl_int_002-1];
        spin_length_diapo->setValue(pntmygl->length_diapo);
        pntmygl->f_follow_timeline(10);
    }
    f_recalc_length_audio();
}

/*void mainfrm::f_showhide_timeline_diapo()
{
    if ( frame_support_timeline_diapo->geometry().y() < this->height()-30 )
    {
        QPropertyAnimation *animation = new QPropertyAnimation(frame_support_timeline_diapo, "geometry");
        animation->setDuration(500);
        animation->setStartValue(QRect(frame_support_timeline_diapo->geometry().x(),frame_support_timeline_diapo->geometry().y(),frame_support_timeline_diapo->width(),frame_support_timeline_diapo->height()));
        animation->setEndValue(QRect(frame_support_timeline_diapo->geometry().x(),this->height(),frame_support_timeline_diapo->width(),frame_support_timeline_diapo->height()));
        animation->setEasingCurve(QEasingCurve::InOutCubic);
        animation->start();
    }
    else
    {
        QPropertyAnimation *animation = new QPropertyAnimation(frame_support_timeline_diapo, "geometry");
        animation->setDuration(500);
        animation->setStartValue(QRect(frame_support_timeline_diapo->geometry().x(),frame_support_timeline_diapo->geometry().y(),frame_support_timeline_diapo->width(),frame_support_timeline_diapo->height()));
        animation->setEndValue(QRect(frame_support_timeline_diapo->geometry().x(),this->height()-frame_support_timeline_diapo->height(),frame_support_timeline_diapo->width(),frame_support_timeline_diapo->height()));
        animation->setEasingCurve(QEasingCurve::InOutCubic);
        animation->start();
    }
}*/

void mainfrm::f_mark_visible(int value)
{
    pntmygl->f_mark_vis(screen_timeline->pos_x,value);
    pntmygl->f_follow_timeline(screen_timeline->pos_x);
}

void mainfrm::f_s_action_adjtime(int timedi)
{
    pntmygl->f_save_diapo(num_current_diapo);

    int wl_int1 = 0;
    int wl_int2 = 0;

    while ( wl_int1 < nbre_diapos )
    {
        wl_int2 = 0;

        while ( wl_int2 < 20 && pntmygl->tab_save_diapo[wl_int1][wl_int2] != "$#$" )
        {
            wl_int2++;
        }

        if ( pntmygl->tab_save_diapo[wl_int1][wl_int2] == "$#$" )
        {
            pntmygl->tab_save_diapo[wl_int1][wl_int2+1] = QString::number(timedi);
            timeline_diapo->tab_duration[wl_int1] = timedi;
        }

        wl_int1++;
    }

    timeline_diapo->repaint();
}

void mainfrm::f_select_diapos_th(diapos_th* hdlm)
{
    pntmygl->f_save_diapo(num_current_diapo);

    // *** NETTOYAGE DE L'ACCUM BUFFER ***
    //pntmygl->f_netbuf();

    hdl_current_diapo->is_edit = 0;
    hdl_current_diapo->repaint();
    hdl_current_diapo = hdlm;
    hdl_current_diapo->is_edit = 1;
    hdl_current_diapo->repaint();

    int wl_int_001 = 0;
    while ( table_hdl_diapo[wl_int_001] != hdlm )
    {
        wl_int_001++;
    }
    num_current_diapo = wl_int_001;
    f_load_diapo(wl_int_001);
    spin_length_diapo->setValue(pntmygl->length_diapo);

    timeline_diapo->num_current_diapo = wl_int_001;

    if ( wl_int_001 == 0 )
    {
        if ( timeline_diapo->tab_duration[wl_int_001]/2 < 8 )
        {
            spintrandur->setMaximum(timeline_diapo->tab_duration[wl_int_001]/2);
        }
        else
        {
            spintrandur->setMaximum(8);
        }
    }
    else
    {
        if ( timeline_diapo->tab_duration[wl_int_001] > timeline_diapo->tab_duration[wl_int_001-1] )
        {
            if ( timeline_diapo->tab_duration[wl_int_001-1]/2 < 8 )
            {
                spintrandur->setMaximum(timeline_diapo->tab_duration[wl_int_001-1]/2);
            }
            else
            {
                spintrandur->setMaximum(8);
            }
        }
        else
        {
            if ( timeline_diapo->tab_duration[wl_int_001]/2 < 8 )
            {
                spintrandur->setMaximum(timeline_diapo->tab_duration[wl_int_001]/2);
            }
            else
            {
                spintrandur->setMaximum(8);
            }
        }
    }

    must_update = 0;
    if ( pntmygl->str_trans != "" && pntmygl->str_trans != wg_str_int_004 )
    {
        lst_trans_smile->setCurrentIndex(lst_trans_smile->findText(pntmygl->str_trans,Qt::MatchExactly | Qt::MatchCaseSensitive));
    }
    else
    {
        lst_trans_smile->setCurrentIndex(0);
    }

    if ( pntmygl->is_mblur == 0 )
    {
        check_motion_blur->setChecked(false);
    }
    else
    {
        check_motion_blur->setChecked(true);
    }

    if ( pntmygl->is_fog == 0 )
    {
        check_fog->setChecked(false);
    }
    else
    {
        check_fog->setChecked(true);
    }

    must_update = 1;

    screen_timeline->num_select = 0;
    screen_timeline->pos_x = 10;
    screen_timeline->repaint();

    pntmygl->num_select = 0;
    //pntmygl->updateGL();

    pntmygl->f_follow_timeline(10);
}

void mainfrm::f_load_theme_3d()
{
    //pntmygl->f_init_tabcoo();

    QList<QListWidgetItem *> selectthe = frame_support_th3d->selectedItems();
    QListWidgetItem *thetxt = new QListWidgetItem;
    thetxt = selectthe.at(0);

    pntmygl->f_load_theme(thetxt->statusTip(),thetxt->text());

    if ( pntmygl->is_mblur == 0 )
    {
        check_motion_blur->setChecked(false);
    }
    else
    {
        check_motion_blur->setChecked(true);
    }
}

void mainfrm::f_move_start()
{
    screen_timeline->num_select = 0;
    screen_timeline->pos_x = 10;
    screen_timeline->repaint();
    pntmygl->f_follow_timeline(10);
}

void mainfrm::f_tool_change(int tool)
{
    if ( tool == 0 )
    {
        pbgz->setChecked(true);
        pbrx->setChecked(false);
        pbry->setChecked(false);
        pbrz->setChecked(false);
        pbrl->setChecked(false);
        return;
    }

    if ( tool == 1 )
    {
        pbgz->setChecked(false);
        pbrx->setChecked(true);
        pbry->setChecked(false);
        pbrz->setChecked(false);
        pbrl->setChecked(false);
        return;
    }

    if ( tool == 2 )
    {
        pbgz->setChecked(false);
        pbrx->setChecked(false);
        pbry->setChecked(true);
        pbrz->setChecked(false);
        pbrl->setChecked(false);
        return;
    }

    if ( tool == 3 )
    {
        pbgz->setChecked(false);
        pbrx->setChecked(false);
        pbry->setChecked(false);
        pbrz->setChecked(true);
        pbrl->setChecked(false);
        return;
    }

    if ( tool == 4 )
    {
        pbgz->setChecked(false);
        pbrx->setChecked(false);
        pbry->setChecked(false);
        pbrz->setChecked(false);
        pbrl->setChecked(true);
        return;
    }
}

void mainfrm::f_change_length_diapo(int ldia)
{
    if ( must_update == 1 )
    {
        screen_timeline->length_diapo = ldia;
        pntmygl->length_diapo = ldia;
        timeline_diapo->tab_duration[num_current_diapo] = ldia;
        timeline_diapo->repaint();
        screen_timeline->repaint();
    }
}

void mainfrm::f_change_length_translide(int ldia)
{
    if ( must_update == 1 )
    {
        pntmygl->lgt_trans = ldia;
    }
}

void mainfrm::f_change_length_diapo_from_tetra(int ldia)
{
    screen_timeline->length_diapo = ldia;
    pntmygl->length_diapo = ldia;
    screen_timeline->repaint();
    timeline_diapo->tab_duration[num_current_diapo] = ldia;
    timeline_diapo->repaint();
    must_update = 0;
    spin_length_diapo->setValue(ldia);
    must_update = 1;
}

void mainfrm::f_color_back_slide()
{
    if ( must_update == 1 )
    {
        QImage wl_puis_001(1024,1024,QImage::Format_ARGB32_Premultiplied);
        QPainter p;

        p.begin(&wl_puis_001);
        p.setBrush(QColor(pntwheel8->red,pntwheel8->green,pntwheel8->blue));
        p.drawRect(0,0,1024,1024);
        p.end();

        pntmygl->wg_fd_tx = 1.0;
        pntmygl->wg_fd_ty = 1.0;

        QImage f = QGLWidget::convertToGLFormat( wl_puis_001 );

        glDeleteTextures (1,&pntmygl->texture_diapo[41]);
        glGenTextures (1,&pntmygl->texture_diapo[41]);
        glBindTexture (GL_TEXTURE_2D, pntmygl->texture_diapo[41]);

        glTexParameteri (GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_LINEAR);
        glTexParameteri (GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_LINEAR);

        glTexImage2D (GL_TEXTURE_2D, 0, GL_RGBA, f.width(), f.height(),
                      0, GL_RGBA, GL_UNSIGNED_BYTE, f.bits());

        pntmygl->isback = 1;

        pntmygl->back_color = QString::number(pntwheel8->red) + ":" + QString::number(pntwheel8->green) + ":" + QString::number(pntwheel8->blue);
        pntmygl->updateGL();
    }
}

void mainfrm::f_load_back()
{
    if ( pntmygl->back_color.mid(0,1) != "/" )
    {
        if ( pntmygl->back_color == "0:0:0" )
        {
            pntmygl->isback = 0;
            //pntmygl->updateGL();
        }
        else
        {
            QStringList wl_explode = pntmygl->back_color.split(":", QString::SkipEmptyParts);
            pntwheel8->red = wl_explode.at(0).toInt();
            pntwheel8->green = wl_explode.at(1).toInt();
            pntwheel8->blue = wl_explode.at(2).toInt();

            QImage wl_puis_001(1024,1024,QImage::Format_ARGB32_Premultiplied);
            QPainter p;

            p.begin(&wl_puis_001);
            p.setBrush(QColor(pntwheel8->red,pntwheel8->green,pntwheel8->blue));
            p.drawRect(0,0,1024,1024);
            p.end();

            pntmygl->wg_fd_tx = 1.0;
            pntmygl->wg_fd_ty = 1.0;

            QImage f = QGLWidget::convertToGLFormat( wl_puis_001 );

            glDeleteTextures (1,&pntmygl->texture_diapo[41]);
            glGenTextures (1,&pntmygl->texture_diapo[41]);
            glBindTexture (GL_TEXTURE_2D, pntmygl->texture_diapo[41]);

            glTexParameteri (GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_LINEAR);
            glTexParameteri (GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_LINEAR);

            glTexImage2D (GL_TEXTURE_2D, 0, GL_RGBA, f.width(), f.height(),
                          0, GL_RGBA, GL_UNSIGNED_BYTE, f.bits());

            pntmygl->isback = 1;
            pntmygl->back_color = QString::number(pntwheel8->red) + ":" + QString::number(pntwheel8->green) + ":" + QString::number(pntwheel8->blue);
            //pntmygl->updateGL();
        }
    }
    else
    {
        QString wl_myfic = pntmygl->back_color;
        QImage wl_img_texture;

        if ( wl_img_texture.load(wl_myfic) == true )
        {
            if ( wl_img_texture.width() > wl_img_texture.height() )
            {
                wl_img_texture = wl_img_texture.scaledToWidth(1024,Qt::SmoothTransformation);
            }
            else
            {
                wl_img_texture = wl_img_texture.scaledToHeight(1024,Qt::SmoothTransformation);
            }

            QImage wl_puis_001(1024,1024,QImage::Format_ARGB32_Premultiplied);
            wl_puis_001 = wl_img_texture.copy ( 0, 0, 1024, 1024);

            pntmygl->wg_fd_tx = (float)wl_img_texture.width()/(float)1024;
            pntmygl->wg_fd_ty = (float)wl_img_texture.height()/(float)1024;

            QImage f = QGLWidget::convertToGLFormat( wl_puis_001 );

            glDeleteTextures (1,&pntmygl->texture_diapo[41]);
            glGenTextures (1,&pntmygl->texture_diapo[41]);
            glBindTexture (GL_TEXTURE_2D, pntmygl->texture_diapo[41]);

            glTexParameteri (GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_LINEAR);
            glTexParameteri (GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_LINEAR);

            glTexImage2D (GL_TEXTURE_2D, 0, GL_RGBA, f.width(), f.height(),
                          0, GL_RGBA, GL_UNSIGNED_BYTE, f.bits());

            pntmygl->isback = 1;
            pntmygl->back_color = wl_myfic;
            //pntmygl->updateGL();
        }
    }
}

void mainfrm::f_play_diapo()
{
    isrendering = 0;
    pntmygl->f_netbuf();
    if ( player_isplaying == false )
    {
        pntmygl->f_save_diapo(num_current_diapo);
        frame_toolslide->setDisabled(true);
        screen_timeline->setDisabled(true);
        pntmygl->num_select = 0;
        screen_timeline->num_select = 0;
        screen_timeline->repaint();
        //frame_bottom_slide->setDisabled(true);
        frame_support_timeline_diapo->setDisabled(true);
        player_isplaying = true;
        pntmygl->f_follow_timeline(10);
        pos_playing = 10;
        cpt_trt_trans = 0;

        //pntmygl->setGeometry(-dvdxsize,0,dvdxsize,dvdysize);

        // *** CHARGEMENT DIAPO NOIRE ***
        sx_tr_diapo = dvdxsize; ///2;
        sy_tr_diapo = dvdysize; ///2;

        QPixmap wl_tmp_001(sx_tr_diapo,sy_tr_diapo);
        wl_tmp_001.fill(QColor(0,0,0));
        while ( isrendering < 251 )
        {
            pntmygl->table_preview_transition[isrendering] = wl_tmp_001.toImage();
            isrendering++;
        }

        //pntmygl->resizeGL(dvdxsize/2,dvdysize/2);

        frame_msk_ed3d->setPixmap(wl_tmp_001);
        frame_msk_ed3d->show();
        frame_msk_ed3d->raise();

        isrendering = 0;
        thread_trans_render_sequence = 0;
        mysynctime.restart();
        f_play_diapo_boucle();
    }
    else
    {
        player_isplaying = false;
        frame_toolslide->setEnabled(true);
        frame_bottom_slide->setEnabled(true);
        frame_support_timeline_diapo->setEnabled(true);
        screen_timeline->setEnabled(true);

        //pntmygl->resizeGL(dvdxsize,dvdysize);
        //pntmygl->setGeometry(0,0,pntmygl->width(),pntmygl->height());
        frame_msk_ed3d->hide();
        frame_msk_ed3d->lower();
        //f_load_diapo(num_current_diapo);
    }
}

void mainfrm::f_fwd_diapo()
{
    if ( screen_timeline->num_select > 0 )
    {
        int wl_int_001 = 0;
        int wl_int_002 = 9999;

        while ( screen_timeline->tab_mark[wl_int_001][0] != "" )
        {
            if ( screen_timeline->tab_mark[wl_int_001][0].toInt() > screen_timeline->pos_x )
            {
                if ( screen_timeline->tab_mark[wl_int_001][0].toInt() < wl_int_002 )
                {
                    wl_int_002 = screen_timeline->tab_mark[wl_int_001][0].toInt();
                }
            }
            wl_int_001++;
        }

        if ( wl_int_002 < 9999 )
        {
            pntmygl->f_follow_timeline(wl_int_002);
            screen_timeline->pos_x = wl_int_002;
            screen_timeline->repaint();
        }
    }
}

void mainfrm::f_rwd_diapo()
{
    if ( screen_timeline->num_select > 0 )
    {
        int wl_int_001 = 0;
        int wl_int_002 = 0;

        while ( screen_timeline->tab_mark[wl_int_001][0] != "" )
        {
            if ( screen_timeline->tab_mark[wl_int_001][0].toInt() < screen_timeline->pos_x )
            {
                if ( screen_timeline->tab_mark[wl_int_001][0].toInt() > wl_int_002 )
                {
                    wl_int_002 = screen_timeline->tab_mark[wl_int_001][0].toInt();
                }
            }
            wl_int_001++;
        }

        if ( wl_int_002 > 0 )
        {
            pntmygl->f_follow_timeline(wl_int_002);
            screen_timeline->pos_x = wl_int_002;
            screen_timeline->repaint();
        }
    }
}

void mainfrm::f_play_diapo_boucle()
{
    float wlincr = (float)((float)(screen_timeline->width()-20)/(float)((float)wg_fps_int*(float)pntmygl->length_diapo));

    pos_playing = pos_playing + wlincr;

    float wl_avtrans = (float)(((float)pntmygl->lgt_trans_old*(float)25)+3)*(float)wlincr;
    float wl_aptrans = (float)(((float)pntmygl->lgt_trans*(float)25)+2)*(float)wlincr;

    if ( pos_playing >= screen_timeline->width()-10 )
    {
        num_current_diapo++;
        progress_render_smile_2->setValue(num_current_diapo);

        pos_playing = 10;
        if ( num_current_diapo < nbre_diapos )
        {
            pntmygl->f_init_tabcoo();
            f_load_diapo(num_current_diapo);

            progress_render_smile->setValue(0);
            progress_render_smile->setMaximum(pntmygl->length_diapo*25);
            label_61->setText(tr("Progression diapositive :") + " "  + QString::number(num_current_diapo+1));
            spin_length_diapo->setValue(pntmygl->length_diapo);
            cpt_trt_trans = 0;
            thread_trans_render_sequence = 0;
        }
        else
        {
            if ( isrendering == 0 )
            {
                num_current_diapo = 0;
                f_load_diapo(num_current_diapo);
                spin_length_diapo->setValue(pntmygl->length_diapo);
                cpt_trt_trans = 0;
                thread_trans_render_sequence = 0;

                // *** CHARGEMENT DIAPO NOIRE ***
                //QPixmap wl_tmp_001(sx_tr_diapo,sy_tr_diapo);
                //wl_tmp_001.fill(QColor(0,0,0));

                while ( isrendering < 250 )
                {
                    pntmygl->table_preview_transition[isrendering] = pntmygl->table_preview_transition[250];
                    isrendering++;
                }

                isrendering = 0;
            }
            else
            {
                f_render_smile_2();
                return;
            }
        }
    }
    pntmygl->f_follow_timeline(pos_playing);
    screen_timeline->pos_x = pos_playing;
    screen_timeline->repaint();

    if ( isrendering == 1 )
    {
        progress_render_smile->setValue(progress_render_smile->value()+1);

        wg_myimg_render = pntmygl->grabFrameBuffer ( false );

        if ( pos_playing < screen_timeline->width()-wl_avtrans )
        {
            if ( pos_playing > wl_aptrans )
            {
                if ( cpt_trt_trans > 0 )
                {
                    cpt_trt_trans = 0;
                }

                QString wl_tmp_004 = "0000000000";
                QString wl_tmp_005 = QString::number(wg_int_001);
                wl_tmp_004.replace( 10 - wl_tmp_005.length(), wl_tmp_005.length(), wl_tmp_005);

                wg_myimg_render.save( path_project + "/RDR/" + wl_tmp_004 + ".jpg" ,"JPEG", wg_jpg_qual );
                wg_int_001++;
            }
            else
            {
                if ( pntmygl->str_trans == "" || pntmygl->str_trans == wg_str_int_004 )
                {
                    if ( cpt_trt_trans > 0 )
                    {
                        cpt_trt_trans = 0;
                    }

                    QString wl_tmp_004 = "0000000000";
                    QString wl_tmp_005 = QString::number(wg_int_001);
                    wl_tmp_004.replace( 10 - wl_tmp_005.length(), wl_tmp_005.length(), wl_tmp_005);

                    wg_myimg_render.save( path_project + "/RDR/" + wl_tmp_004 + ".jpg" ,"JPEG", wg_jpg_qual );
                    wg_int_001++;
                }
                else
                {
                    f_update_trans_render();
                    cpt_trt_trans++;
                    return;
                }
            }
        }
        else
        {
            pntmygl->table_preview_transition[cpt_trt_trans] = wg_myimg_render;
            cpt_trt_trans++;
        }
    }
    else
    {
        wg_myimg_render = pntmygl->grabFrameBuffer ( false );

        if ( pos_playing < screen_timeline->width()-wl_avtrans )
        {
            if ( pos_playing > wl_aptrans )
            {
                if ( cpt_trt_trans > 0 )
                {
                    cpt_trt_trans = 0;
                }
                frame_msk_ed3d->setPixmap(QPixmap::fromImage(wg_myimg_render,Qt::AutoColor));
            }
            else
            {               
                if ( pntmygl->str_trans == "" || pntmygl->str_trans == wg_str_int_004 )
                {
                    if ( cpt_trt_trans > 0 )
                    {
                        cpt_trt_trans = 0;
                    }

                    frame_msk_ed3d->setPixmap(QPixmap::fromImage(wg_myimg_render,Qt::AutoColor));
                }
                else
                {
                    f_update_trans_render();
                    cpt_trt_trans++;
                    return;
                }
            }
        }
        else
        {
            pntmygl->table_preview_transition[cpt_trt_trans] = wg_myimg_render;
            cpt_trt_trans++;
        }
    }

    if ( player_isplaying == true )
    {
        if ( isrendering == 1 )
        {
            QTimer::singleShot(2, this, SLOT(f_play_diapo_boucle()));
        }
        else
        {
            wl_wait = mysynctime.elapsed();

            if ( wl_wait < 40 )
            {
                    wl_wait = 40-wl_wait;
            }
            else
            {
                    wl_wait = 2;
            }
            mysynctime.restart();

            QTimer::singleShot(wl_wait, this, SLOT(f_play_diapo_boucle()));
        }
    }
}

void mainfrm::f_update_trans_render()
{   
    QImage dstImage(dvdxsize,dvdysize,QImage::Format_ARGB32);

    thptradia *thread_trans_render = new thptradia();
    thread_trans_render->dstImage = &dstImage;
    thptradia *thread_trans_render_2 = new thptradia();
    thread_trans_render_2->dstImage = &dstImage;

    wg_myimg_render = pntmygl->grabFrameBuffer ( false );

    if ( pntmygl->str_trans != "crossfade" )
    {
            thread_trans_render->invert = "1";
            thread_trans_render->srcImage2 = pntmygl->table_preview_transition[cpt_trt_trans];
            thread_trans_render->srcImage = wg_myimg_render; //pntmygl->grabFrameBuffer ( false );
            thread_trans_render->srcImage3.load(qApp->applicationDirPath()+"/Bibliotheque/Luma/" + pntmygl->str_trans + ".png");
            thread_trans_render->srcImage3 = thread_trans_render->srcImage3.scaled(sx_tr_diapo, sy_tr_diapo, Qt::IgnoreAspectRatio, Qt::FastTransformation);
            thread_trans_render->type_trans = 0;

            thread_trans_render_2->invert = "1";
            thread_trans_render_2->srcImage2 = thread_trans_render->srcImage2;
            thread_trans_render_2->srcImage = thread_trans_render->srcImage;
            thread_trans_render_2->srcImage3 = thread_trans_render->srcImage3;
            thread_trans_render_2->type_trans = 0;
    }
    else
    {
            thread_trans_render->srcImage = pntmygl->table_preview_transition[cpt_trt_trans];
            thread_trans_render->srcImage2 = wg_myimg_render; //pntmygl->grabFrameBuffer ( false );
            thread_trans_render->type_trans = 1;

            thread_trans_render_2->srcImage2 = thread_trans_render->srcImage2;
            thread_trans_render_2->srcImage = thread_trans_render->srcImage;
            thread_trans_render_2->type_trans = 1;
    }

    thread_trans_render->minx = 0;
    thread_trans_render->maxx = thread_trans_render->srcImage2.width();
    thread_trans_render->miny = 0;
    thread_trans_render->maxy = thread_trans_render->srcImage2.height()/2;

    thread_trans_render->sequence = thread_trans_render_sequence;

    thread_trans_render_2->minx = 0;
    thread_trans_render_2->maxx = thread_trans_render->maxx;
    thread_trans_render_2->maxy = thread_trans_render_2->srcImage2.height();
    thread_trans_render_2->miny = thread_trans_render_2->maxy/2;


    thread_trans_render_2->sequence = thread_trans_render_sequence;

    thread_trans_render->start();
    thread_trans_render_2->start();
    thread_trans_render->wait();
    thread_trans_render_2->wait();

    if ( isrendering == 0 )
    {
        frame_msk_ed3d->setPixmap(QPixmap::fromImage(dstImage,Qt::AutoColor));
    }
    else
    {
        QString wl_str_tmp_004 = "0000000000";
        QString wl_str_tmp_005 = QString::number(wg_int_001);
        wl_str_tmp_004.replace( 10 - wl_str_tmp_005.length(), wl_str_tmp_005.length(), wl_str_tmp_005);

        dstImage.save( path_project + "/RDR/" + wl_str_tmp_004 + ".jpg" ,"JPEG", wg_jpg_qual );
        wg_int_001++;
    }


    thread_trans_render_sequence = thread_trans_render_sequence + (float)((float)100/(float)((pntmygl->lgt_trans*25)-2)); // (float)(100/((screen_timeline->width()/10)/(float)(screen_timeline->width()/(float)(25*screen_timeline->length_diapo))-1));

    if ( thread_trans_render_sequence > 100 )
    {
        thread_trans_render_sequence = 100;
        cpt_trt_trans = 0;
    }

    delete thread_trans_render;
    delete thread_trans_render_2;

    if ( player_isplaying == true )
    {
        QTimer::singleShot(2, this, SLOT(f_play_diapo_boucle()));
    }
}

void mainfrm::f_render_smile()
{
    QPixmap wl_pix_001(this->width(),this->height());
    wl_pix_001.fill(QColor(0,0,0,240));
    mask_interface->setPixmap(wl_pix_001);

    smenuBar->setDisabled(true);

    mask_interface->show();
    mask_interface->raise();

    frame_choose_encode->show();
    frame_choose_encode->raise();
}

void mainfrm::f_render_smile_2()
{
    progress_render_smile->setValue(progress_render_smile->maximum());
    progress_render_smile_3->setMaximum(100);
    f_end_smile_encode();
}

void mainfrm::f_end_smile_encode()
{
    // *** GENERATION DE LA VIDEO ***
    //progress_render_smile->setValue(0);

    if ( pntmygl->wg_sav_niv_qual == 0 )
    {
        pntmygl->quality_low();
    }

    if ( frame_path_smile->isEnabled() == true )
    {
        QFile wmyficext;
        QTextStream outext(&wmyficext);

        wmyficext.setFileName(path_project + "/RDR/gene.sh");
        wmyficext.open( QIODevice::WriteOnly );
        outext << "cd " + path_project + "/RDR/" << endl;
        outext << "sox -n -t wav -c 2 silent.wav trim 0 " + QString::number(timeline_diapo->wg_cumul) << endl;

        if ( nbre_audio_track > 0 )
        {
            // *** CALCUL TEMPS POUR BANDE AUDIO ***

            int wl_int_001 = 0;
            int wl_cumul_before = 0;
            int wl_cumul_after = 0;

            int wl_durfin = 0;
            int wl_durfou = 0;
            int wl_lgtfou = 0;

            while ( wl_int_001 < nbre_diapos )
            {
                if ( wl_int_001 < hdl_audio->position )
                {
                    wl_cumul_before = wl_cumul_before + timeline_diapo->tab_duration[wl_int_001];
                }
                else
                {
                    if ( wl_int_001 == hdl_audio->position )
                    {
                        wl_durfin = timeline_diapo->tab_duration[wl_int_001];
                    }
                    wl_cumul_after = wl_cumul_after + timeline_diapo->tab_duration[wl_int_001];
                    if ( wl_cumul_after >= hdl_audio->length_media || wl_int_001 == nbre_diapos-1 )
                    {
                        wl_durfou = timeline_diapo->tab_duration[wl_int_001];
                        wl_lgtfou = wl_cumul_after-timeline_diapo->tab_duration[wl_int_001];
                    }
                }
                wl_int_001++;
            }

            QString wl_str_fade = "";
            wl_str_fade = "fade t " + QString::number(wl_durfin) + " " + QString::number(wl_lgtfou) + " " + QString::number(wl_durfou);

            outext << "ffmpeg -y -i '" + hdl_audio->title_audio + "' trscode.wav" << endl;
            outext << "sox silent.wav -t wav -c 2 -r 44100 debut.wav trim 0:0:0.0 " << QString::number(wl_cumul_before) << endl;
            outext << "sox trscode.wav -t wav -c 2 -r 44100 temp.wav trim 0:0:0.0 " << QString::number(wl_cumul_after) << " " << wl_str_fade << endl;
            outext << "rm -f silent.wav" << endl;
            outext << "sox -S debut.wav temp.wav silent.wav" << endl;
        }

        outext << "ffmpeg -i silent.wav -y -acodec ac3 -ab 192k silent.mp2" << endl;

        if ( combo_fmt_smile->currentIndex() < 6 )
        {
            if ( dvd_format == "4/3" )
            {
                outext << "mencoder \"mf://*.jpg\" -noskip -mf w=" + QString::number(dvdxsize) + ":h=" + QString::number(dvdysize) + ":fps=" + wg_fps + ":type=jpg -o \"" + wg_str_int_001 + "\" -oac lavc -ovc lavc -vf harddup -of mpeg -mpegopts format=dvd:tsaf:vbitrate=9700:muxrate=7500 -srate 48000 -af lavcresample=48000 -lavcopts vcodec=mpeg2video:aspect=4/3:vrc_buf_size=1835:vrc_maxrate=9800:threads=" + QString::number(nbre_threads) + ":vbitrate=9800:keyint=12:vstrict=0:acodec=ac3:abitrate=192 -cache 8192 -audiofile silent.mp2 | perl " + qApp->applicationDirPath() + "/fake.pl" << endl;
            }
            else
            {
                outext << "mencoder \"mf://*.jpg\" -noskip -mf w=" + QString::number(dvdxsize) + ":h=" + QString::number(dvdysize) + ":fps=" + wg_fps + ":type=jpg -o \"" + wg_str_int_001 + "\" -oac lavc -ovc lavc -vf harddup -of mpeg -mpegopts format=dvd:tsaf:vbitrate=9700:muxrate=7500 -srate 48000 -af lavcresample=48000 -lavcopts vcodec=mpeg2video:aspect=16/9:vrc_buf_size=1835:vrc_maxrate=9800:threads=" + QString::number(nbre_threads) + ":vbitrate=9800:keyint=12:vstrict=0:acodec=ac3:abitrate=192 -cache 8192 -audiofile silent.mp2 | perl " + qApp->applicationDirPath() + "/fake.pl" << endl;
            }
        }
        else
        {
            if ( combo_fmt_smile->currentIndex() == 6 )
            {
                if ( dvd_format == "4/3" )
                {
                    outext << "mencoder \"mf://*.jpg\" -noskip -mf w=" + QString::number(dvdxsize) + ":h=" + QString::number(dvdysize) + ":fps=" + wg_fps + ":type=jpg -o \"" + wg_str_int_001 + "\" -ovc lavc -lavcopts vcodec=msmpeg4v2:vbitrate=800:aspect=4/3 -oac mp3lame -lameopts cbr:br=128 -audiofile silent.mp2 | perl " + qApp->applicationDirPath() + "/fake.pl" << endl;
                }
                else
                {
                    outext << "mencoder \"mf://*.jpg\" -noskip -mf w=" + QString::number(dvdxsize) + ":h=" + QString::number(dvdysize) + ":fps=" + wg_fps + ":type=jpg -o \"" + wg_str_int_001 + "\" -ovc lavc -lavcopts vcodec=msmpeg4v2:vbitrate=800:aspect=16/9 -oac mp3lame -lameopts cbr:br=128 -audiofile silent.mp2 | perl " + qApp->applicationDirPath() + "/fake.pl" << endl;
                }
            }
            else
            {
                int sizy = 1920 / ((float)dvdxsize / (float)dvdysize);

                int cropy = (sizy-1080)/2;

                outext << "mencoder \"mf://*.jpg\" -noskip -mf fps=" + wg_fps + ":type=jpg -o \"" + wg_str_int_001 + "\" -oac mp3lame -ovc lavc -lavcopts vcodec=mpeg4:threads=" + QString::number(nbre_threads) + ":vbitrate=2160000:mbd=2:keyint=132:v4mv:vqmin=3:vlelim=-4:vcelim=7:lumi_mask=0.07:dark_mask=0.10:naq:vqcomp=0.7:vqblur=0.2:mpeg_quant:aspect=16/9 -vf scale=1920:" + QString::number(sizy) + ",crop=1920:1080:0:" + QString::number(cropy) + " -audiofile silent.mp2 | perl " + qApp->applicationDirPath() + "/fake.pl" << endl;
            }
        }
        outext << "rm -f *.wav" << endl;
        outext << "rm -f silent.mp2" << endl;
        outext << "exit" << endl;
        wmyficext.close();
        wg_string_003 = "";
        QString programf = "bash";
        QStringList argumentsf;
        argumentsf << path_project + "/RDR/gene.sh";

        proc_ffmpeg.setProcessChannelMode(QProcess::MergedChannels);
        proc_ffmpeg.start(programf,argumentsf);

        proc_ffmpeg.waitForFinished(-1);
    }

    progress_render_smile_3->setValue(100);
    frame_toolslide->setEnabled(true);
    frame_bottom_slide->setEnabled(true);
    frame_support_timeline_diapo->setEnabled(true);

    if ( wg_string_003.lastIndexOf( "FATAL:" ) >= 0 )
    {
        if ( isnotify == 1 )
        {
                QString programf = "notify-send";
                QStringList argumentsf;
                argumentsf << "-i" << qApp->applicationDirPath() + "/Interface/emblem2.png";
                argumentsf << "2ManDVD";
                argumentsf << tr("La generation du diaporama a echouee");
                proc_ffmpeg.setProcessChannelMode(QProcess::MergedChannels);
                proc_ffmpeg.start(programf,argumentsf);
        }
        else
        {
            QString programf = "kdialog";
            QStringList argumentsf;
            argumentsf << "--passivepopup";
            argumentsf << tr("La generation du diaporama a echouee");
            argumentsf << "--title";
            argumentsf << "'2ManDVD'";

            proc_ffmpeg.setProcessChannelMode(QProcess::MergedChannels);
            proc_ffmpeg.start(programf,argumentsf);
        }

        QMessageBox::information(this, name_application, tr("La generation du diaporama a echouee"));
    }
    else
    {
        if ( isnotify == 1 )
        {
                QString programf = "notify-send";
                QStringList argumentsf;
                argumentsf << "-i" << qApp->applicationDirPath() + "/Interface/emblem2.png";
                argumentsf << "2ManDVD";
                argumentsf << tr("La generation du diaporama est terminee avec succes");
                proc_ffmpeg.setProcessChannelMode(QProcess::MergedChannels);
                proc_ffmpeg.start(programf,argumentsf);
        }
        else
        {
            QString programf = "kdialog";
            QStringList argumentsf;
            argumentsf << "--passivepopup";
            argumentsf << tr("La generation du diaporama est terminee avec succes");
            argumentsf << "--title";
            argumentsf << "'2ManDVD'";

            proc_ffmpeg.setProcessChannelMode(QProcess::MergedChannels);
            proc_ffmpeg.start(programf,argumentsf);
        }

        QMessageBox::information(this, name_application, tr("La generation du diaporama s est achevee avec succes"));
    }
    frame_render_smile->hide();
    smenuBar->setEnabled(true);
    player_isplaying = false;
    mask_interface->hide();
    pntmygl->f_netbuf();

    frame_choose_encode->hide();
}

void mainfrm::f_pro_smile()
{
    frame_pro_smile->raise();
    frame_topbt_smile->raise();
    if ( frame_pro_smile->geometry().y() >= frame_toolslide->height() )
    {
        QPropertyAnimation *animation = new QPropertyAnimation(frame_pro_smile, "geometry");
        animation->setDuration(900);
        animation->setStartValue(QRect(0,frame_pro_smile->geometry().y(),frame_pro_smile->width(),frame_pro_smile->height()));
        animation->setEndValue(QRect(0,0,frame_pro_smile->width(),frame_pro_smile->height()));
        animation->setEasingCurve(QEasingCurve::InOutQuart);
        animation->start();

        QPropertyAnimation *animation2 = new QPropertyAnimation(frame_thm_smile, "geometry");
        animation2->setDuration(700);
        animation2->setStartValue(QRect(0,frame_thm_smile->geometry().y(),frame_thm_smile->width(),frame_thm_smile->height()));
        animation2->setEndValue(QRect(0,frame_toolslide->height(),frame_thm_smile->width(),frame_thm_smile->height()));
        animation2->setEasingCurve(QEasingCurve::InOutQuart);
        animation2->start();
    }
}

void mainfrm::f_thm_smile()
{
    frame_thm_smile->raise();
    frame_topbt_smile->raise();
    if ( frame_thm_smile->geometry().y() >= frame_toolslide->height() )
    {
        QPropertyAnimation *animation = new QPropertyAnimation(frame_thm_smile, "geometry");
        animation->setDuration(900);
        animation->setStartValue(QRect(0,frame_thm_smile->geometry().y(),frame_thm_smile->width(),frame_thm_smile->height()));
        animation->setEndValue(QRect(0,0,frame_thm_smile->width(),frame_thm_smile->height()));
        animation->setEasingCurve(QEasingCurve::InOutQuart);
        animation->start();

        QPropertyAnimation *animation2 = new QPropertyAnimation(frame_pro_smile, "geometry");
        animation2->setDuration(700);
        animation2->setStartValue(QRect(0,frame_pro_smile->geometry().y(),frame_pro_smile->width(),frame_pro_smile->height()));
        animation2->setEndValue(QRect(0,frame_toolslide->height(),frame_pro_smile->width(),frame_pro_smile->height()));
        animation2->setEasingCurve(QEasingCurve::InOutQuart);
        animation2->start();
    }
}

void mainfrm::f_select_them_smile()
{
    if ( screen_timeline->num_select > 0 )
    {
        QList<QListWidgetItem *> selectthe = frame_th_msk_smile->selectedItems();
        QListWidgetItem *thetxt = new QListWidgetItem;
        thetxt = selectthe.at(0);

        if ( thetxt->text() != wg_str_int_004 )
        {
            pntmygl->f_load_mask(thetxt->text(),screen_timeline->num_select);
        }
        else
        {
            pntmygl->f_load_mask("",screen_timeline->num_select);
        }
    }
}

/*void mainfrm::f_load_image_back_smile()
{
    myfileopen *hdlfopen = new myfileopen(this);
    hdlfopen->setDirectory(pntmygl->wg_path_images);
    hdlfopen->source = 1;
    hdlfopen->setWindowTitle(tr("Image d arrier plan"));
    hdlfopen->setFilter("(*.PNG *.png *.jpg *.JPG *.jeg *.JPEG)");
    connect(hdlfopen, SIGNAL(change_image(QString)),this, SLOT(f_open_ipreview(QString)));
    hdlfopen->show();
    connect(hdlfopen, SIGNAL(filesSelected( const QStringList )),pntmygl, SLOT(f_load_background( const QStringList )));
    connect(hdlfopen, SIGNAL(f_close()),this, SLOT(f_hide_preview()));
    connect(hdlfopen, SIGNAL(finished(int)),this, SLOT(f_hide_preview()));
}*/

void mainfrm::f_valid_coord_diapo()
{
    pntmygl->f_mark_pos(screen_timeline->pos_x,10,slider_opa_slide->value(),slider_blur_img->value());
}

void mainfrm::f_px_changed(QString px)
{
    if ( pntmygl->num_select > 0 && must_update == 1 )
    {
        pntmygl->tab_coo[pntmygl->num_select][0] = px.toFloat();
        pntmygl->updateGL();
    }
}

void mainfrm::f_py_changed(QString py)
{
    if ( pntmygl->num_select > 0 && must_update == 1 )
    {
        pntmygl->tab_coo[pntmygl->num_select][1] = py.toFloat();
        pntmygl->updateGL();
    }
}

void mainfrm::f_pz_changed(QString pz)
{
    if ( pntmygl->num_select > 0 && must_update == 1 )
    {
        pntmygl->tab_coo[pntmygl->num_select][2] = pz.toFloat();
        pntmygl->updateGL();
    }
}

void mainfrm::f_rx_changed(QString rx)
{
    if ( pntmygl->num_select > 0 && must_update == 1 )
    {
        pntmygl->tab_coo[pntmygl->num_select][5] = rx.toFloat();
        pntmygl->updateGL();
    }
}

void mainfrm::f_ry_changed(QString ry)
{
    if ( pntmygl->num_select > 0 && must_update == 1 )
    {
        pntmygl->tab_coo[pntmygl->num_select][6] = ry.toFloat();
        pntmygl->updateGL();
    }
}

void mainfrm::f_rz_changed(QString rz)
{
    if ( pntmygl->num_select > 0 && must_update == 1 )
    {
        pntmygl->tab_coo[pntmygl->num_select][7] = rz.toFloat();
        pntmygl->updateGL();
    }
}

void mainfrm::f_action_talea()
{
    pntmygl->f_save_diapo(num_current_diapo);

    int wl_int_001 = 0;
    int wl_int_002 = 0;
    int wl_random_value;
    while ( wl_int_001 < nbre_diapos )
    {
        wl_random_value = rand()%(nombre_transitions);
        if ( wl_random_value < 1 )
        {
            wl_random_value = 1;
        }

        wl_int_002 = 0;

        while ( pntmygl->tab_save_diapo[wl_int_001][wl_int_002] != "$#$" )
        {
            wl_int_002++;
        }

        pntmygl->tab_save_diapo[wl_int_001][wl_int_002+3] = lst_trans_smile->itemText(wl_random_value) + "}1";

        if ( wl_int_001 == num_current_diapo )
        {
            must_update = 0;
            pntmygl->str_trans = lst_trans_smile->itemText(wl_random_value);
            pntmygl->lgt_trans = 1;
            lst_trans_smile->setCurrentIndex(lst_trans_smile->findText(pntmygl->str_trans,Qt::MatchExactly | Qt::MatchCaseSensitive));
            must_update = 1;
        }

        wl_int_001++;
    }
    f_select_diapos_th(table_hdl_diapo[num_current_diapo]);
}

void mainfrm::f_godrop_diapo()
{
    pntmygl->f_save_diapo(num_current_diapo); // *** TODO A VERIFIER ***

    int pos_drag = 0;
    pos_drag = timeline_diapo->drop_x/60;

    if ( pos_drag == num_current_diapo )
    {
        return;
    }

    if ( pos_drag > nbre_diapos-1 )
    {
        pos_drag = nbre_diapos-1;
    }

    int wl_int_001 = pos_drag;
    int wl_int_002 = 0;

    if ( pos_drag < num_current_diapo)
    {
        while ( wl_int_001 < num_current_diapo )
        {
            QPropertyAnimation *animation2 = new QPropertyAnimation(table_hdl_diapo[wl_int_001], "geometry");
            animation2->setDuration(300);
            animation2->setStartValue(QRect(table_hdl_diapo[wl_int_001]->geometry().x(),table_hdl_diapo[wl_int_001]->geometry().y(),table_hdl_diapo[wl_int_001]->width(),table_hdl_diapo[wl_int_001]->height()));
            animation2->setEndValue(QRect(table_hdl_diapo[wl_int_001+1]->geometry().x(),table_hdl_diapo[wl_int_001+1]->geometry().y(),table_hdl_diapo[wl_int_001]->width(),table_hdl_diapo[wl_int_001]->height()));
            animation2->setEasingCurve(QEasingCurve::InOutCubic);
            animation2->start();
            wl_int_001++;
        }
    }
    else
    {
        wl_int_001 = num_current_diapo+1;
        while ( wl_int_001 <= pos_drag )
        {
            QPropertyAnimation *animation2 = new QPropertyAnimation(table_hdl_diapo[wl_int_001], "geometry");
            animation2->setDuration(300);
            animation2->setStartValue(QRect(table_hdl_diapo[wl_int_001]->geometry().x(),table_hdl_diapo[wl_int_001]->geometry().y(),table_hdl_diapo[wl_int_001]->width(),table_hdl_diapo[wl_int_001]->height()));
            animation2->setEndValue(QRect(table_hdl_diapo[wl_int_001-1]->geometry().x(),table_hdl_diapo[wl_int_001-1]->geometry().y(),table_hdl_diapo[wl_int_001]->width(),table_hdl_diapo[wl_int_001]->height()));
            animation2->setEasingCurve(QEasingCurve::InOutCubic);
            animation2->start();
            wl_int_001++;
        }
    }

    QPropertyAnimation *animation = new QPropertyAnimation(table_hdl_diapo[num_current_diapo], "geometry");
    animation->setDuration(800);
    animation->setStartValue(QRect(table_hdl_diapo[num_current_diapo]->geometry().x(),table_hdl_diapo[num_current_diapo]->geometry().y(),table_hdl_diapo[num_current_diapo]->width(),table_hdl_diapo[num_current_diapo]->height()));
    animation->setEndValue(QRect(table_hdl_diapo[pos_drag]->geometry().x(),table_hdl_diapo[pos_drag]->geometry().y(),table_hdl_diapo[pos_drag]->width(),table_hdl_diapo[pos_drag]->height()));
    animation->setEasingCurve(QEasingCurve::InOutCubic);
    animation->start();

    // *** PERMUTATION DES HANDLES ***
    diapos_th *hdltmp;

    QString save_diapo_tmp[45];

    if ( pos_drag < num_current_diapo)
    {
        wl_int_001 = num_current_diapo;
        hdltmp = table_hdl_diapo[num_current_diapo];

        wl_int_002 = 0;
        while ( wl_int_002 < 45 )
        {
            save_diapo_tmp[wl_int_002] = pntmygl->tab_save_diapo[num_current_diapo][wl_int_002];
            wl_int_002++;
        }

        while ( wl_int_001 > pos_drag )
        {
            table_hdl_diapo[wl_int_001] = table_hdl_diapo[wl_int_001-1];
            wl_int_002 = 0;
            while ( wl_int_002 < 45 )
            {
                pntmygl->tab_save_diapo[wl_int_001][wl_int_002] = pntmygl->tab_save_diapo[wl_int_001-1][wl_int_002];
                wl_int_002++;
            }
            wl_int_001--;
        }
        table_hdl_diapo[pos_drag] = hdltmp;

        wl_int_002 = 0;
        while ( wl_int_002 < 45 )
        {
            pntmygl->tab_save_diapo[pos_drag][wl_int_002] = save_diapo_tmp[wl_int_002];
            wl_int_002++;
        }
    }
    else
    {
        wl_int_001 = num_current_diapo;
        hdltmp = table_hdl_diapo[num_current_diapo];

        wl_int_002 = 0;
        while ( wl_int_002 < 45 )
        {
            save_diapo_tmp[wl_int_002] = pntmygl->tab_save_diapo[num_current_diapo][wl_int_002];
            wl_int_002++;
        }

        while ( wl_int_001 < pos_drag )
        {
            table_hdl_diapo[wl_int_001] = table_hdl_diapo[wl_int_001+1];
            wl_int_002 = 0;
            while ( wl_int_002 < 45 )
            {
                pntmygl->tab_save_diapo[wl_int_001][wl_int_002] = pntmygl->tab_save_diapo[wl_int_001+1][wl_int_002];
                wl_int_002++;
            }
            wl_int_001++;
        }
        table_hdl_diapo[pos_drag] = hdltmp;

        wl_int_002 = 0;
        while ( wl_int_002 < 45 )
        {
            pntmygl->tab_save_diapo[pos_drag][wl_int_002] = save_diapo_tmp[wl_int_002];
            wl_int_002++;
        }
    }
    num_current_diapo = pos_drag;
}

void mainfrm::f_lst_trans_smile_changed(int)
{
    if ( must_update == 1 )
    {
        pntmygl->str_trans = lst_trans_smile->currentText();
    }
}

void mainfrm::f_dupliquer_diaposth(diapos_th*)
{
    //qDebug() << "num_current_diapo = " << num_current_diapo << "    " << pntmygl->nombre_diapos;

    pntmygl->f_save_diapo(num_current_diapo);

    diapos_th *newdiapo = new diapos_th(timeline_diapo);

    table_hdl_diapo[nbre_diapos] = newdiapo;

    connect(newdiapo, SIGNAL(select_diapoth(diapos_th*) ),this, SLOT(f_select_diapos_th(diapos_th*)));
    connect(newdiapo, SIGNAL(delete_diapoth(diapos_th*) ),this, SLOT(f_delete_diaposth(diapos_th*)));
    connect(newdiapo, SIGNAL(dupliquer_diapoth(diapos_th*) ),this, SLOT(f_dupliquer_diaposth(diapos_th*)));
    connect(newdiapo, SIGNAL(enter_diath(diapos_th*) ),this, SLOT(f_enter_diath(diapos_th*)));
    connect(newdiapo, SIGNAL(leave_diath(diapos_th*) ),this, SLOT(f_leave_diath(diapos_th*)));

    if ( num_current_diapo+1 >= nbre_diapos )
    {
        newdiapo->setGeometry( nbre_diapos * 60, 0, 50, 50 );

        int wl_int_001 = 0;

        //qDebug() << pntmygl->nombre_diapos << " " << num_current_diapo;

        while ( wl_int_001 < 45 ) //&& pntmygl->tab_save_diapo[num_current_diapo+1][wl_int_001] != "" )
        {
            pntmygl->tab_save_diapo[nbre_diapos][wl_int_001] = pntmygl->tab_save_diapo[num_current_diapo][wl_int_001];
            //qDebug() << wl_int_001 << " - " << pntmygl->tab_save_diapo[pntmygl->nombre_diapos][wl_int_001];
            wl_int_001++;
        }

        table_hdl_diapo[nbre_diapos] = newdiapo;
        newdiapo->draw_image = table_hdl_diapo[num_current_diapo]->draw_image;
        newdiapo->is_edit = 0;
        newdiapo->show();
    }
    else
    {
        int wl_i1 = num_current_diapo;
        while ( wl_i1 < nbre_diapos )
        {
            if ( wl_i1 < nbre_diapos-1 )
            {
                QPropertyAnimation *animation2 = new QPropertyAnimation(table_hdl_diapo[wl_i1], "geometry");
                animation2->setDuration(300);
                animation2->setStartValue(QRect(table_hdl_diapo[wl_i1]->geometry().x(),table_hdl_diapo[wl_i1]->geometry().y(),table_hdl_diapo[wl_i1]->width(),table_hdl_diapo[wl_i1]->height()));
                animation2->setEndValue(QRect(table_hdl_diapo[wl_i1+1]->geometry().x(),table_hdl_diapo[wl_i1+1]->geometry().y(),table_hdl_diapo[wl_i1]->width(),table_hdl_diapo[wl_i1]->height()));
                animation2->setEasingCurve(QEasingCurve::InOutCubic);
                animation2->start();
            }
            else
            {
                QPropertyAnimation *animation2 = new QPropertyAnimation(table_hdl_diapo[wl_i1], "geometry");
                animation2->setDuration(300);
                animation2->setStartValue(QRect(table_hdl_diapo[wl_i1]->geometry().x(),table_hdl_diapo[wl_i1]->geometry().y(),table_hdl_diapo[wl_i1]->width(),table_hdl_diapo[wl_i1]->height()));
                animation2->setEndValue(QRect(table_hdl_diapo[wl_i1]->geometry().x()+60,table_hdl_diapo[wl_i1]->geometry().y(),table_hdl_diapo[wl_i1]->width(),table_hdl_diapo[wl_i1]->height()));
                animation2->setEasingCurve(QEasingCurve::InOutCubic);
                animation2->start();
            }

            wl_i1++;
        }

        int wl_int_001 = nbre_diapos;
        int wl_int_002;
        //hdltmp = table_hdl_diapo[num_current_diapo];

        while ( wl_int_001 >= num_current_diapo )
        {
            //qDebug() << wl_int_001 << " " << num_current_diapo;
            table_hdl_diapo[wl_int_001+1] = table_hdl_diapo[wl_int_001];
            wl_int_002 = 0;
            while ( wl_int_002 < 45 )
            {
                pntmygl->tab_save_diapo[wl_int_001+1][wl_int_002] = pntmygl->tab_save_diapo[wl_int_001][wl_int_002];
                wl_int_002++;
            }
            wl_int_001--;
        }
        table_hdl_diapo[num_current_diapo] = newdiapo;
        newdiapo->draw_image = table_hdl_diapo[num_current_diapo+1]->draw_image;
        newdiapo->is_edit = 0;
        newdiapo->show();

        /*wl_int_002 = 0;
        while ( wl_int_002 < 45 )
        {
            pntmygl->tab_save_diapo[num_current_diapo][wl_int_002] = "";
            wl_int_002++;
        }
        pntmygl->tab_save_diapo[num_current_diapo][0] = "$#$";*/

        wl_int_001 = 0;
        while ( wl_int_001 < 45 ) //&& pntmygl->tab_save_diapo[num_current_diapo+1][wl_int_001] != "" )
        {
            pntmygl->tab_save_diapo[num_current_diapo][wl_int_001] = pntmygl->tab_save_diapo[num_current_diapo+1][wl_int_001];
            //qDebug() << wl_int_001 << " - " << pntmygl->tab_save_diapo[pntmygl->nombre_diapos][wl_int_001];
            wl_int_001++;
        }

        newdiapo->setGeometry( num_current_diapo * 60, 0, 50, 50 );
    }

    timeline_diapo->repaint();

    nbre_diapos++;
}

void mainfrm::f_actionDiaporama_automatique()
{
    QString mydir = QFileDialog::getExistingDirectory( this, tr("Choisissez le dossier contenant vos images"), pntmygl->wg_path_images, QFileDialog::ShowDirsOnly | QFileDialog::DontResolveSymlinks);
    if ( mydir != "" )
    {
        pntmygl->wg_path_images = mydir;
        QPixmap wl_pix_002(this->width(),this->height());
        wl_pix_002.fill(QColor(0,0,0,240));
        mask_interface->setPixmap(wl_pix_002);

        smenuBar->setDisabled(true);

        mask_interface->show();
        mask_interface->raise();

        frame_holy_param->show();
        frame_holy_param->raise();
        wg_string_001 = mydir;
    }
}

        /*pb_holy->setValue(0);
        frame_holy->show();
        frame_holy->raise();

        wg_string_001 = mydir;

        //f_actionDiaporama_automatique_2(mydir);
        QTimer::singleShot(10, this, SLOT(f_actionDiaporama_automatique_2()));*/
//    }
//}

void mainfrm::f_actionDiaporama_automatique_1()
{
    frame_holy_param->hide();

    pb_holy->setValue(0);
    frame_holy->show();
    frame_holy->raise();

    //f_actionDiaporama_automatique_2(mydir);
    QTimer::singleShot(5, this, SLOT(f_actionDiaporama_automatique_2()));
}

void mainfrm::f_cancel_actionDiaporama_automatique()
{
    frame_holy_param->hide();
    smenuBar->setEnabled(true);

    mask_interface->hide();
}

void mainfrm::f_actionDiaporama_automatique_2()
{
        QString mydir = wg_string_001;
        QDir tmpdir;
        tmpdir.setPath(mydir);
        QStringList filters;
        filters << "*.jpg" << "*.JPG" << "*.jpeg" << "*.JPEG" << "*.png" << "*.PNG";
        tmpdir.setNameFilters(filters);
        if ( combo_pardiapauto->currentIndex() == 0 && checkBox_sort_diapauto->isChecked() == false )
        {
            tmpdir.setSorting(QDir::Name);
        }
        else
        {
            if ( combo_pardiapauto->currentIndex() == 0 && checkBox_sort_diapauto->isChecked() == true )
            {
                tmpdir.setSorting(QDir::Name | QDir::Reversed);
            }
            else
            {
                if ( combo_pardiapauto->currentIndex() == 1 && checkBox_sort_diapauto->isChecked() == false )
                {
                    tmpdir.setSorting(QDir::Time);
                }
                else
                {
                    if ( combo_pardiapauto->currentIndex() == 1 && checkBox_sort_diapauto->isChecked() == true )
                    {
                        tmpdir.setSorting(QDir::Time | QDir::Reversed);
                    }
                    else
                    {
                        if ( combo_pardiapauto->currentIndex() == 2 && checkBox_sort_diapauto->isChecked() == false )
                        {
                            tmpdir.setSorting(QDir::Size);
                        }
                        else
                        {
                            tmpdir.setSorting(QDir::Size | QDir::Reversed);
                        }
                    }
                }
            }
        }
        tmpdir.sorting();
        QString wlfile;
        int wl_int_001 = 0;
        int wl_int_002 = 0;
        int wl_int_003 = 0;
        int wl_int_004 = 0;
        int wl_random_value;

        QString tab_dia_string[1000];
        QListWidgetItem *wl_item;
        QStringList wl_exp;
        QStringList wl_explode;
        QImage wl_img;
        QString nameth;
        QImage wl_img_texture;
        QString wl_str_001;
        QString wl_str_002;

        if ( tmpdir.count() > 0 )
        {
            foreach (wlfile, tmpdir.entryList(QDir::Files))
            {
                tab_dia_string[wl_int_001] = mydir + "/" + wlfile;
                //qDebug() << "FILE = " << wl_int_001 << " " << tab_dia_string[wl_int_001];
                wl_int_001++;
            }
            //wl_int_001--;

            //qDebug() << wl_int_001;
            //qDebug() << "------------------";

            pb_holy->setMaximum(wl_int_001);

            //qDebug() << "NBPHOTO= " << wl_int_001;

            while ( wl_int_002 < wl_int_001 )
            {
                diapos_th *newdiapo = new diapos_th(timeline_diapo);
                newdiapo->setGeometry( nbre_diapos*60, 0, 50, 50 );
                newdiapo->draw_image.load(tab_dia_string[wl_int_002]);
                newdiapo->draw_image = newdiapo->draw_image.scaled(38,38);
                newdiapo->is_edit = 0;
                newdiapo->is_first = 0;
                newdiapo->show();

                table_hdl_diapo[nbre_diapos] = newdiapo;

                connect(newdiapo, SIGNAL(select_diapoth(diapos_th*) ),this, SLOT(f_select_diapos_th(diapos_th*)));
                connect(newdiapo, SIGNAL(delete_diapoth(diapos_th*) ),this, SLOT(f_delete_diaposth(diapos_th*)));
                connect(newdiapo, SIGNAL(dupliquer_diapoth(diapos_th*) ),this, SLOT(f_dupliquer_diaposth(diapos_th*)));
                connect(newdiapo, SIGNAL(enter_diath(diapos_th*) ),this, SLOT(f_enter_diath(diapos_th*)));
                connect(newdiapo, SIGNAL(leave_diath(diapos_th*) ),this, SLOT(f_leave_diath(diapos_th*)));

                timeline_diapo->repaint();

                wl_random_value = rand()%(nombre_themes_3d);
                if ( wl_random_value < 0 )
                {
                    wl_random_value = 0;
                }

                wl_item = frame_support_th3d->item(wl_random_value);
                nameth = wl_item->text();
                wl_exp = wl_item->statusTip().split("_",QString::KeepEmptyParts);

                timeline_diapo->tab_duration[nbre_diapos] = wl_exp.at(1).toInt();
                timeline_diapo->repaint();

                for (wl_int_003 = 3; wl_int_003 < wl_exp.size(); ++wl_int_003)
                {                  
                    if ( wl_img_texture.load(qApp->applicationDirPath() + "/Bibliotheque/3d/" + nameth + "_" + QString::number(wl_int_003-2) + ".png") == true )
                    {
                        if ( wl_img_texture.width() > wl_img_texture.height() )
                        {
                            wl_img_texture = wl_img_texture.scaledToWidth(1024,Qt::SmoothTransformation);
                        }
                        else
                        {
                            wl_img_texture = wl_img_texture.scaledToHeight(1024,Qt::SmoothTransformation);
                        }

                        wl_explode = wl_exp.at(wl_int_003).split("$",QString::SkipEmptyParts);

                        wl_str_001 =  wl_explode.at(0).mid(wl_explode.at(0).lastIndexOf( ":" )+1,wl_explode.at(0).length()-(wl_explode.at(0).lastIndexOf( ":" )+1));
                        wl_str_001.replace(QString("underscore"), QString("_"));

                        wl_str_002 = wl_explode.at(0).mid(6,wl_explode.at(0).lastIndexOf( ":" )-6) + "$";

                        wl_int_004 = 1;

                        while ( wl_int_004 < wl_explode.count() )
                        {
                            wl_str_002 = wl_str_002 + wl_explode.at(wl_int_004) + "$";
                            wl_int_004++;
                        }
                        //qDebug() << wl_explode.at(0).mid(2,3);
                        //tab_diapo[i-2][5] = wl_exp_3.at(1);                                             // *** SCALE ***

                        pntmygl->tab_save_diapo[nbre_diapos][wl_int_003-2] = qApp->applicationDirPath() + "/Bibliotheque/3d/" + nameth + "_" + QString::number(wl_int_003-2) + ".png" + "$1024$" + QString::number(1024/(wl_img_texture.width()/wl_img_texture.height())) + "$" + wl_str_001 + "$0:0$" + wl_explode.at(0).mid(2,3) + "$" + wl_exp.at(wl_int_003).mid(0,1) + "$0/0/0/0$0$" + wl_str_002; // + "$1.0";$
                        //qDebug() << pntmygl->tab_save_diapo[nbre_diapos][wl_int_003-2];
                    }
                    else
                    {
                        if ( wl_int_002 < wl_int_001 )
                        {
                            if ( wl_img.load(tab_dia_string[wl_int_002]) == true )
                            {
                                if ( wl_img.width() > wl_img.height() )
                                {
                                    wl_img = wl_img.scaledToWidth(1024,Qt::SmoothTransformation);
                                }
                                else
                                {
                                    wl_img = wl_img.scaledToHeight(1024,Qt::SmoothTransformation);
                                }

                                wl_explode = wl_exp.at(wl_int_003).split("$",QString::SkipEmptyParts);

                                wl_str_001 =  wl_explode.at(0).mid(wl_explode.at(0).lastIndexOf( ":" )+1,wl_explode.at(0).length()-(wl_explode.at(0).lastIndexOf( ":" )+1));
                                wl_str_001.replace(QString("underscore"), QString("_"));

                                wl_str_002 = wl_explode.at(0).mid(6,wl_explode.at(0).lastIndexOf( ":" )-6) + "$";

                                wl_int_004 = 1;

                                while ( wl_int_004 < wl_explode.count() )
                                {
                                    wl_str_002 = wl_str_002 + wl_explode.at(wl_int_004) + "$";
                                    wl_int_004++;
                                }

                                int sens = pntmygl->f_load_exif(tab_dia_string[wl_int_002]);

                                pntmygl->tab_save_diapo[nbre_diapos][wl_int_003-2] = tab_dia_string[wl_int_002] + "$" + QString::number(wl_img.width()) + "$" + QString::number(wl_img.height()) + "$" + wl_str_001 + "$0:0$1$" + wl_exp.at(wl_int_003).mid(0,1) + "$0/0/0/0$" + QString::number(sens) + "$" + wl_str_002; // + "$1.0";$
                            }
                            else
                            {
                                qDebug() << "ERROR LOADING PHOTO FOR AUTOSLIDESHOW : " << wl_int_002-1 << " " << tab_dia_string[wl_int_002];
                            }
                            wl_int_002++;
                        }
                        else
                        {
                            wl_explode = wl_exp.at(wl_int_003).split("$",QString::SkipEmptyParts);

                            wl_str_001 =  wl_explode.at(0).mid(wl_explode.at(0).lastIndexOf( ":" )+1,wl_explode.at(0).length()-(wl_explode.at(0).lastIndexOf( ":" )+1));
                            wl_str_001.replace(QString("underscore"), QString("_"));

                            wl_str_002 = wl_explode.at(0).mid(6,wl_explode.at(0).lastIndexOf( ":" )-6) + "$";

                            wl_int_004 = 1;

                            while ( wl_int_004 < wl_explode.count() )
                            {
                                wl_str_002 = wl_str_002 + wl_explode.at(wl_int_004) + "$";
                                wl_int_004++;
                            }

                            pntmygl->tab_save_diapo[nbre_diapos][wl_int_003-2] = "NULL$1024$1024$" + wl_str_001 + "$0:0$1$" + wl_exp.at(wl_int_003).mid(0,1) + "$0/0/0/0$0$" + wl_str_002; // + "$1.0";$
                        }
                        pb_holy->setValue(pb_holy->value()+1);
                        pb_holy->repaint();
                    }
                    //pb_holy->setValue(pb_holy->value()+1);
                    //pb_holy->repaint();
                }

                pntmygl->tab_save_diapo[nbre_diapos][wl_int_003-2] = "$#$";

                if ( wl_img_texture.load(qApp->applicationDirPath()+"/Bibliotheque/3d/" + nameth + ".jpg") == true )
                {
                    pntmygl->tab_save_diapo[nbre_diapos][wl_int_003] = qApp->applicationDirPath()+"/Bibliotheque/3d/" + nameth + ".jpg";
                }
                else
                {
                    pntmygl->tab_save_diapo[nbre_diapos][wl_int_003] = "0:0:0";
                }

                wl_random_value = rand()%(nombre_transitions);
                if ( wl_random_value < 1 )
                {
                    wl_random_value = 1;
                }

                pntmygl->tab_save_diapo[nbre_diapos][wl_int_003-1] = wl_exp.at(1);
                pntmygl->tab_save_diapo[nbre_diapos][wl_int_003+1] = lst_trans_smile->itemText(wl_random_value) + "}1";
                pntmygl->tab_save_diapo[nbre_diapos][wl_int_003+2] = wl_exp.at(2);
                pntmygl->tab_save_diapo[nbre_diapos][wl_int_003+3] = "0";

                nbre_diapos++;
                //wl_int_002++;
            }
            timeline_diapo->max_diapo = nbre_diapos;
        }
        frame_holy->hide();

        screen_timeline->repaint();

        if ( (nbre_diapos*70) > timeline_diapo->width() )
        {
            timeline_diapo->setGeometry(timeline_diapo->geometry().x(),0,nbre_diapos*70,timeline_diapo->height());
            scroll_timeline_smile->setMaximum(timeline_diapo->width()-frame_support_timeline->width());

            //qDebug() << myeffect_global->opacity();
            
            if ( myeffect_global->opacity() < 1.0 )
            {
                QPropertyAnimation *animation = new QPropertyAnimation(myeffect_global, "opacity");
                animation->setDuration(1000);
                animation->setStartValue(qreal(myeffect_global->opacity()));
                animation->setEndValue(qreal(1.0));
                animation->start();
            }
        }

        f_recalc_length_audio();
        timeline_diapo->repaint();
        smenuBar->setEnabled(true);

        mask_interface->hide();
}

void mainfrm::f_dial_smile_light(int)
{
    /*if ( pntmygl->num_select == 0 )
    {
        return;
    }*/

    if ( must_update == 1 ) //&& thread_img_smile->must_redraw == 1 )
    {
        if ( pntmygl->tab_diapo[pntmygl->num_select][0] != "NULL"  )
        {
            /*QImage wl_img_texture(1024,1024,QImage::Format_ARGB32);

            if ( wl_img_texture.load(pntmygl->tab_diapo[pntmygl->num_select][0]) == true )
            {
                if ( pntmygl->tab_diapo[pntmygl->num_select][7] != "0/0/0/0" )
                {
                    QStringList wl_explode = pntmygl->tab_diapo[pntmygl->num_select][7].split("/",QString::KeepEmptyParts);
                    wl_img_texture = wl_img_texture.copy(wl_explode.at(0).toFloat(),wl_explode.at(1).toFloat(),wl_explode.at(2).toFloat()-wl_explode.at(0).toFloat(),wl_explode.at(3).toFloat()-wl_explode.at(1).toFloat());
                }

                if ( pntmygl->tab_coo[pntmygl->num_select][10] > 0 )
                {
                    wl_img_texture = pntmygl->blur_shadow(wl_img_texture,pntmygl->tab_coo[pntmygl->num_select][10]);
                }

                if ( wl_img_texture.width() > wl_img_texture.height() )
                {
                    wl_img_texture = wl_img_texture.scaledToWidth(1024,Qt::SmoothTransformation);
                }
                else
                {
                    wl_img_texture = wl_img_texture.scaledToHeight(1024,Qt::SmoothTransformation);
                }

                wl_img_texture = wl_img_texture.convertToFormat ( QImage::Format_ARGB32, Qt::AutoColor ); //_Premultiplied

                QColor trtcolor;
                QRgb srcPixel;

                thread_img_smile->c_r = 0;
                thread_img_smile->c_v = 0;
                thread_img_smile->c_b = 0;

                for (int y = 0; y < wl_img_texture.height(); y++)
                {
                        for (int x = 0; x < wl_img_texture.width(); x++)
                        {
                                srcPixel = wl_img_texture.pixel(x, y);
                                trtcolor = srcPixel;
                                thread_img_smile->c_r = thread_img_smile->c_r + trtcolor.red();
                                thread_img_smile->c_v = thread_img_smile->c_v + trtcolor.green();
                                thread_img_smile->c_b = thread_img_smile->c_b + trtcolor.blue();
                        }
                }
                thread_img_smile->c_r = thread_img_smile->c_r / (wl_img_texture.height()*wl_img_texture.width());
                thread_img_smile->c_v = thread_img_smile->c_v / (wl_img_texture.height()*wl_img_texture.width());
                thread_img_smile->c_b = thread_img_smile->c_b / (wl_img_texture.height()*wl_img_texture.width());

                thread_img_smile->cont = dial_smile_contrast->value();
                thread_img_smile->lumi = valulc;
                thread_img_smile->opacity = 255;
                thread_img_smile->wlimg = wl_img_texture.convertToFormat ( QImage::Format_ARGB32_Premultiplied, Qt::AutoColor );
                thread_img_smile->run();

                pntmygl->tab_diapo[pntmygl->num_select][4] = QString::number(dial_smile_light->value()) + ":" + QString::number(dial_smile_contrast->value());
            }*/
            pntmygl->tab_diapo[pntmygl->num_select][4] = QString::number(dial_smile_light->value()) + ":" + QString::number(dial_smile_contrast->value());
            pntmygl->f_reload_img(pntmygl->num_select);
            pntmygl->updateGL();
        }
    }
}

void mainfrm::f_dial_smile_contraste(int)
{
    /*if ( pntmygl->num_select == 0 )
    {
        return;
    }*/

    if ( must_update == 1 ) //&& thread_img_smile->must_redraw == 1 )
    {
        /*if ( pntmygl->tab_diapo[pntmygl->num_select][0] != "NULL"  )
        {
            QImage wl_img_texture(1024,1024,QImage::Format_ARGB32);

            if ( wl_img_texture.load(pntmygl->tab_diapo[pntmygl->num_select][0]) == true )
            {
                if ( pntmygl->tab_diapo[pntmygl->num_select][7] != "0/0/0/0" )
                {
                    QStringList wl_explode = pntmygl->tab_diapo[pntmygl->num_select][7].split("/",QString::KeepEmptyParts);
                    wl_img_texture = wl_img_texture.copy(wl_explode.at(0).toFloat(),wl_explode.at(1).toFloat(),wl_explode.at(2).toFloat()-wl_explode.at(0).toFloat(),wl_explode.at(3).toFloat()-wl_explode.at(1).toFloat());
                }

                if ( pntmygl->tab_coo[pntmygl->num_select][10] > 0 )
                {
                    wl_img_texture = pntmygl->blur_shadow(wl_img_texture,pntmygl->tab_coo[pntmygl->num_select][10]);
                }

                if ( wl_img_texture.width() > wl_img_texture.height() )
                {
                    wl_img_texture = wl_img_texture.scaledToWidth(1024,Qt::SmoothTransformation);
                }
                else
                {
                    wl_img_texture = wl_img_texture.scaledToHeight(1024,Qt::SmoothTransformation);
                }
                wl_img_texture = wl_img_texture.convertToFormat ( QImage::Format_ARGB32_Premultiplied, Qt::AutoColor ); //_Premultiplied

                QColor trtcolor;
                QRgb srcPixel;

                thread_img_smile->c_r = 0;
                thread_img_smile->c_v = 0;
                thread_img_smile->c_b = 0;

                for (int y = 0; y < wl_img_texture.height(); y++)
                {
                        for (int x = 0; x < wl_img_texture.width(); x++)
                        {
                                srcPixel = wl_img_texture.pixel(x, y);
                                trtcolor = srcPixel;
                                thread_img_smile->c_r = thread_img_smile->c_r + trtcolor.red();
                                thread_img_smile->c_v = thread_img_smile->c_v + trtcolor.green();
                                thread_img_smile->c_b = thread_img_smile->c_b + trtcolor.blue();
                        }
                }
                thread_img_smile->c_r = thread_img_smile->c_r / (wl_img_texture.height()*wl_img_texture.width());
                thread_img_smile->c_v = thread_img_smile->c_v / (wl_img_texture.height()*wl_img_texture.width());
                thread_img_smile->c_b = thread_img_smile->c_b / (wl_img_texture.height()*wl_img_texture.width());

                thread_img_smile->cont = valulc;
                thread_img_smile->opacity = 255;
                thread_img_smile->lumi = dial_smile_light->value();

                thread_img_smile->wlimg = wl_img_texture; //.convertToFormat ( QImage::Format_ARGB32_Premultiplied, Qt::AutoColor );
                thread_img_smile->run();

                pntmygl->tab_diapo[pntmygl->num_select][4] = QString::number(dial_smile_light->value()) + ":" + QString::number(dial_smile_contrast->value());
            }
        }*/
        pntmygl->tab_diapo[pntmygl->num_select][4] = QString::number(dial_smile_light->value()) + ":" + QString::number(dial_smile_contrast->value());
        pntmygl->f_reload_img(pntmygl->num_select);
        pntmygl->updateGL();
    }
}

/*void mainfrm::f_refresh_lc_smile()
{

    QImage wl_puis_001(1024,1024,QImage::Format_ARGB32_Premultiplied);
    wl_puis_001 = thread_img_smile->wlimg.copy ( 0, 0, thread_img_smile->wlimg.width(), thread_img_smile->wlimg.height());

    if ( pntmygl->tab_diapo[pntmygl->num_select][3] != "" )
    {
        QImage wl_image_2(qApp->applicationDirPath()+"/Bibliotheque/Masks/"+pntmygl->tab_diapo[pntmygl->num_select][3]+".png");
        wl_image_2 = wl_image_2.scaled(thread_img_smile->wlimg.width(),thread_img_smile->wlimg.height());
        wl_image_2 = wl_image_2.convertToFormat ( QImage::Format_ARGB32, Qt::AutoColor ); //_Premultiplied

        QPainter g;

        QPainter::CompositionMode mode = (QPainter::CompositionMode)6;

        g.begin(&wl_puis_001);
        g.setCompositionMode ( mode );
        g.drawImage(QRect(0,0,-1,-1),wl_image_2);

        QString wl_str_001 = qApp->applicationDirPath() + "/Bibliotheque/Masks/2t_" + pntmygl->tab_diapo[pntmygl->num_select][3] + ".png";
        QImage wl_over_mask;

        if ( wl_over_mask.load(wl_str_001) == true )
        {
            wl_over_mask = wl_over_mask.scaled(thread_img_smile->wlimg.width(),thread_img_smile->wlimg.height());
            wl_over_mask.invertPixels(QImage::InvertRgb);
            wl_over_mask = wl_over_mask.convertToFormat ( QImage::Format_ARGB32, Qt::AutoColor ); //_Premultiplied
            g.setCompositionMode ( (QPainter::CompositionMode)0 );
            g.drawImage(QRect(0,0,-1,-1),wl_over_mask);
        }

        g.end();
    }


    QImage f = QGLWidget::convertToGLFormat( wl_puis_001 );

    glDeleteTextures (1,&pntmygl->texture_diapo[pntmygl->num_select]);
    glGenTextures (1,&pntmygl->texture_diapo[pntmygl->num_select]);
    glBindTexture (GL_TEXTURE_2D, pntmygl->texture_diapo[pntmygl->num_select]);

    glTexParameteri (GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_LINEAR);
    //glTexParameteri (GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_LINEAR);

    glTexImage2D (GL_TEXTURE_2D, 0, GL_RGBA, f.width(), f.height(),
                  0, GL_RGBA, GL_UNSIGNED_BYTE, f.bits());

    pntmygl->updateGL();
}*/

void mainfrm::f_load_diapo(int num_diapo)
{
    lst_calques->clear();

    // *** DEPLACEMENT POINTEUR EDITION ***
    hdl_current_diapo->is_edit = 0;
    hdl_current_diapo->repaint();

    // *** NETTOYAGE DE L'ACCUM BUFFER ***
    pntmygl->f_netbuf();
    pntmygl->f_init_tabcoo();

    int wl_int_001 = 1;
    int wl_int_002 = 0;
    int wl_int_003 = 0;
    int wl_int_004 = 0;
    int oldnum;
    pntmygl->wg_nb_cube = 0;
    //QStringList wg_str_001;
    QStringList wg_str_002;
    QStringList wg_str_003;
    QStringList wl_explode;
    QImage wl_puis_001(1024,1024,QImage::Format_ARGB32_Premultiplied);
    QImage wl_img_texture;
    QImage f;
    QImage wl_image_2;
    QPainter p;
    QPainter g;
    QFont myfont;
    QString wl_myfic;
    QString wl_str_001;
    QImage wl_over_mask;
    myfont.setPixelSize ( 400 );

    pntmygl->must_update = 0;

    linxtxtslide->setText("");
    bt_bold_txtslide->setChecked(false);
    bt_italic_txtslide->setChecked(false);
    bt_underline_txtslide->setChecked(false);

    linxtxtslide->setDisabled(true);
    bt_bold_txtslide->setDisabled(true);
    bt_italic_txtslide->setDisabled(true);
    bt_underline_txtslide->setDisabled(true);

    pntmygl->must_update = 1;

    // *** SUPPRESSION DES ANCIENNES DIAPOS ***
    /*qDebug() << wl_int_002 << " " << nombre_diapos;*/
    /*while ( wl_int_002 < pntmygl->nombre_diapos )
    {
        glDeleteTextures(1, &pntmygl->texture_diapo[wl_int_002+1] );
        wl_int_002++;
    }
    wl_int_002 = 0;*/

    pntmygl->nombre_diapos = 0;
    //qDebug() << "   ";
    //qDebug() << "-----------------------------------------";

    while ( pntmygl->tab_save_diapo[num_diapo][wl_int_001] != "$#$" )
    {
        wg_str_002 = pntmygl->tab_save_diapo[num_diapo][wl_int_001].split("$",QString::KeepEmptyParts); //QString::SkipEmptyParts); //  QString::KeepEmptyParts);

        pntmygl->tab_diapo[wl_int_002+1][0] =  wg_str_002.at(0);
        pntmygl->tab_diapo[wl_int_002+1][1] =  wg_str_002.at(1);
        pntmygl->tab_diapo[wl_int_002+1][2] =  wg_str_002.at(2);
        pntmygl->tab_diapo[wl_int_002+1][3] =  wg_str_002.at(3);
        pntmygl->tab_diapo[wl_int_002+1][4] =  wg_str_002.at(4);
        pntmygl->tab_diapo[wl_int_002+1][5] =  wg_str_002.at(5);
        pntmygl->tab_diapo[wl_int_002+1][6] =  wg_str_002.at(6);
        pntmygl->tab_diapo[wl_int_002+1][7] =  wg_str_002.at(7);
        pntmygl->tab_diapo[wl_int_002+1][8] =  wg_str_002.at(8);

        //qDebug() << "LOAD=" << pntmygl->tab_save_diapo[num_diapo][wl_int_001];

        // *** CHARGEMENT DE LA TEXTURE ***

        //qDebug() << wl_int_002+1 << " " << pntmygl->tab_diapo[wl_int_002+1][0];

        if ( pntmygl->tab_diapo[wl_int_002+1][0] != "NULL" )
        {
            if ( wl_img_texture.load(pntmygl->tab_diapo[wl_int_002+1][0]) == true || pntmygl->tab_diapo[wl_int_002+1][0].mid(0,2) == "?9" )
            {
                if ( pntmygl->tab_diapo[wl_int_002+1][0].mid(0,2) == "?9" )
                {
                    oldnum = pntmygl->num_select;
                    pntmygl->num_select = wl_int_002+1;
                    pntmygl->f_reload_text();
                    pntmygl->num_select = oldnum;
                }
                else
                {
                    pntmygl->f_reload_img(wl_int_002+1);

                    if ( pntmygl->tab_diapo[wl_int_002+1][0].right(4) == ".gif" || pntmygl->tab_diapo[wl_int_002+1][0].right(4) == ".GIF" )
                    {
                        pntmygl->tabgif[wl_int_002+1].setFileName(pntmygl->tab_diapo[wl_int_002+1][0]);
                        pntmygl->tabgif[wl_int_002+1].setCacheMode( QMovie::CacheAll );
                        pntmygl->tabgif[wl_int_002+1].jumpToFrame( 0 );
                    }
                }
            }
            else
            {
                if ( pntmygl->tab_diapo[wl_int_002+1][0].mid(0,1) != "?" )
                {
                    qDebug() << "ERROR LOADING TEXTURE ON f_load_diapo : " << pntmygl->tab_diapo[wl_int_002+1][0];
                }
                else
                {
                    if ( pntmygl->tab_diapo[wl_int_002+1][0].mid(0,2) == "?6" )
                    {
                        wg_str_003 = pntmygl->tab_diapo[wl_int_002+1][0].split(")(",QString::SkipEmptyParts); //QString::SkipEmptyParts); //  QString::KeepEmptyParts);
                        wl_int_004 = 0;

                        pntmygl->wg_nb_cube = 1;

                        while ( wl_int_004 < 6 && wl_int_004 < wg_str_003.count() )
                        {
                            wl_myfic = wg_str_003.at(wl_int_004);

                            if ( wl_int_004 == 0 )
                            {
                                wl_myfic = wl_myfic.mid(2,wl_myfic.length()-2);
                            }

                            if ( wl_img_texture.load(wl_myfic) == true )
                            {
                                if ( wl_img_texture.width() > wl_img_texture.height() )
                                {
                                    wl_img_texture = wl_img_texture.scaledToWidth(1024,Qt::SmoothTransformation);
                                }
                                else
                                {
                                    wl_img_texture = wl_img_texture.scaledToHeight(1024,Qt::SmoothTransformation);
                                }

                                pntmygl->wg_table_photo[wl_int_002+1] = wl_img_texture;

                                //QImage wl_puis_001(1024,1024,QImage::Format_ARGB32_Premultiplied);
                                wl_puis_001 = wl_img_texture.copy ( 0, 0, 1024, 1024);

                                f = QGLWidget::convertToGLFormat( wl_puis_001 );

                                glDeleteTextures (1,&pntmygl->texture_diapo_cube[wl_int_004]);
                                glGenTextures (1,&pntmygl->texture_diapo_cube[wl_int_004]);
                                glBindTexture (GL_TEXTURE_2D, pntmygl->texture_diapo_cube[wl_int_004]);

                                glTexParameteri (GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_LINEAR);
                                glTexParameteri (GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_LINEAR);

                                glTexImage2D (GL_TEXTURE_2D, 0, GL_RGBA, f.width(), f.height(),
                                              0, GL_RGBA, GL_UNSIGNED_BYTE, f.bits());
                            }
                            else
                            {
                                qDebug() << "ERROR LOADING PHOTO FOR CUBE : " << wl_myfic;
                            }
                            wl_int_004++;
                        }
                    }
                }
            }
        }
        else
        {
            p.begin(&wl_puis_001);
            p.setBrush(QColor(50,50,50));
            p.setPen(QColor(20,20,20));
            p.drawRect(0,0,1024,1024);
            p.setFont(myfont);
            p.setPen(QColor(255,255,255));
            p.drawText(QRect(0,0,1024,1024), Qt::AlignCenter,QString::number(wl_int_002+1));
            p.end();

            if ( pntmygl->tab_diapo[wl_int_002+1][3] != "" )
            {
                wl_explode = pntmygl->tab_diapo[wl_int_002+1][3].split("%*",QString::KeepEmptyParts);

                wl_image_2.load(qApp->applicationDirPath()+"/Bibliotheque/Masks/"+wl_explode.at(0)+".png");
                wl_image_2 = wl_image_2.scaled(wl_puis_001.width(),wl_puis_001.height());
                wl_image_2 = wl_image_2.convertToFormat ( QImage::Format_ARGB32, Qt::AutoColor ); //_Premultiplied

                wl_puis_001 = wl_puis_001.convertToFormat ( QImage::Format_ARGB32, Qt::AutoColor ); //_Premultiplied

                QPainter::CompositionMode mode = (QPainter::CompositionMode)6;

                g.begin(&wl_puis_001);
                g.setCompositionMode ( mode );
                g.drawImage(QRect(0,0,-1,-1),wl_image_2);

                wl_str_001 = qApp->applicationDirPath() + "/Bibliotheque/Masks/2t_" + wl_explode.at(0) + ".png";

                if ( wl_over_mask.load(wl_str_001) == true )
                {
                    wl_over_mask = wl_over_mask.scaled(wl_puis_001.width(),wl_puis_001.height());

                    wl_over_mask = pntmygl->f_mutation_overmask(wl_over_mask,wl_explode.at(1) + "%*" + wl_explode.at(2) + "%*" + wl_explode.at(3) + "%*" + wl_explode.at(4) );

                    wl_over_mask = wl_over_mask.convertToFormat ( QImage::Format_ARGB32, Qt::AutoColor ); //_Premultiplied
                    g.setCompositionMode ( (QPainter::CompositionMode)0 );
                    g.drawImage(QRect(0,0,-1,-1),wl_over_mask);
                }

                g.end();
            }

            pntmygl->wg_table_photo[wl_int_002+1] = wl_puis_001;

            f = QGLWidget::convertToGLFormat( wl_puis_001 );

            glDeleteTextures(1, &pntmygl->texture_diapo[wl_int_002+1] );
            glGenTextures (1,&pntmygl->texture_diapo[wl_int_002+1]);
            glBindTexture (GL_TEXTURE_2D, pntmygl->texture_diapo[wl_int_002+1]);

            glTexParameteri (GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_LINEAR);
            glTexParameteri (GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_LINEAR);

            glTexImage2D (GL_TEXTURE_2D, 0, GL_RGBA, f.width(), f.height(),
                          0, GL_RGBA, GL_UNSIGNED_BYTE, f.bits());
        }

        pntmygl->nombre_diapos++;

        f_add_diapo_signal();

        wl_int_003 = 0;
        for (int i = 9; i < wg_str_002.size()-1; ++i)
        {
            pntmygl->tab_coo_timeline[wl_int_002+1][wl_int_003] = wg_str_002.at(i);
            wl_int_003++;
        }

        while ( wl_int_003 < 20 )
        {
            pntmygl->tab_coo_timeline[wl_int_002+1][wl_int_003] = "";
            wl_int_003++;
        }

        wl_int_001++;
        wl_int_002++;
    }

    hdl_current_diapo = table_hdl_diapo[num_diapo];
    hdl_current_diapo->is_edit = 1;
    hdl_current_diapo->repaint();

    pntmygl->length_diapo = pntmygl->tab_save_diapo[num_diapo][wl_int_001+1].toInt();
    pntmygl->back_color = pntmygl->tab_save_diapo[num_diapo][wl_int_001+2];

    wg_str_003 = pntmygl->tab_save_diapo[num_diapo][wl_int_001+3].split("}",QString::KeepEmptyParts);

    pntmygl->str_trans = wg_str_003.at(0);

    if ( wg_str_003.count() > 1 )
    {
        pntmygl->lgt_trans = wg_str_003.at(1).toInt();
    }
    else
    {
        pntmygl->lgt_trans = 1;
    }

    spintrandur->setValue(pntmygl->lgt_trans);

    if ( num_diapo+1 < nbre_diapos )
    {
        int wl_int_999 = 0;
        while ( pntmygl->tab_save_diapo[num_diapo+1][wl_int_999] != "$#$" )
        {
            wl_int_999++;
        }

        wg_str_003 = pntmygl->tab_save_diapo[num_diapo+1][wl_int_999+3].split("}",QString::KeepEmptyParts);

        if ( wg_str_003.count() > 1 )
        {
            pntmygl->lgt_trans_old = wg_str_003.at(1).toInt();
        }
        else
        {
            pntmygl->lgt_trans_old = 1;
        }
    }
    else
    {
        pntmygl->lgt_trans_old = 0;
    }

    pntmygl->is_mblur = pntmygl->tab_save_diapo[num_diapo][wl_int_001+4].toInt();

    must_update = 0;

    if ( pntmygl->str_trans != wg_str_int_004 && pntmygl->str_trans != "" )
    {
        lst_trans_smile->setCurrentIndex(lst_trans_smile->findText(pntmygl->str_trans,Qt::MatchExactly | Qt::MatchCaseSensitive));
    }
    else
    {
        lst_trans_smile->setCurrentIndex(0);
    }
    must_update = 1;

    if ( pntmygl->tab_save_diapo[num_diapo][wl_int_001+5].mid(0,1) != "0" )
    {
        QStringList wl_explode = pntmygl->tab_save_diapo[num_diapo][wl_int_001+5].split(":",QString::KeepEmptyParts);
        pntmygl->is_fog = wl_explode.at(0).toInt();
        pntmygl->fog_red = wl_explode.at(1).toInt();
        pntmygl->fog_green = wl_explode.at(2).toInt();
        pntmygl->fog_blue = wl_explode.at(3).toInt();

        pntmygl->is_fog = 2;

        pntwheel9->setColor(pntmygl->fog_red,pntmygl->fog_green,pntmygl->fog_blue);
    }
    else
    {
        pntmygl->is_fog = 0;
    }

    f_load_back();
}

void mainfrm::f_effect_run(int luma, int contraste)
{
        int cont =  contraste;
        int lumi = luma;

        QColor trtcolor;
        trtcolor.setRed(0);
        trtcolor.setGreen(0);
        trtcolor.setBlue(0);
        trtcolor.setAlpha(0);

        int rouge = 0;
        int vert = 0;
        int bleu = 0;
        int valueadd_R = 0;
        int valueadd_V = 0;
        int valueadd_B = 0;

        QRgb srcPixel;
        int c_r = 0;
        int c_v = 0;
        int c_b = 0;
        int ac_r;
        int ac_v;
        int ac_b;
        //int opacity;

        wg_img_smile_effect = wg_img_smile_effect.convertToFormat(QImage::Format_ARGB32_Premultiplied, Qt::AutoColor);

        for (int y = 0; y < wg_img_smile_effect.height(); y++)
        {
                for (int x = 0; x < wg_img_smile_effect.width(); x++)
                {
                        srcPixel = wg_img_smile_effect.pixel(x, y);
                        trtcolor = srcPixel;
                        c_r = c_r + trtcolor.red();
                        c_v = c_v + trtcolor.green();
                        c_b = c_b + trtcolor.blue();
                }
        }
        c_r = c_r / (wg_img_smile_effect.height()*wg_img_smile_effect.width());
        c_v = c_v / (wg_img_smile_effect.height()*wg_img_smile_effect.width());
        c_b = c_b / (wg_img_smile_effect.height()*wg_img_smile_effect.width());

        for (int y = 0; y < wg_img_smile_effect.height(); y++)
        {
                for (int x = 0; x < wg_img_smile_effect.width(); x++)
                {
                        srcPixel = wg_img_smile_effect.pixel(x, y);
                        trtcolor = srcPixel;
                        //
                        if (qAlpha(srcPixel) > 10 )
                        {
                                if ( cont < 0 )
                                {
                                        ac_r = ( (float)((float)(c_r - trtcolor.red() ) / 100) * -cont);
                                        ac_v = ( (float)((float)(c_v - trtcolor.green() ) / 100) * -cont);
                                        ac_b = ( (float)((float)(c_b - trtcolor.blue() ) / 100) * -cont);
                                }
                                else
                                {
                                        if ( cont > 0 )
                                        {
                                                if ( trtcolor.red() < c_r )
                                                {
                                                        ac_r = ( (float)((float)(0 - trtcolor.red() ) / 100) * -cont);
                                                }
                                                else
                                                {
                                                        ac_r = ( (float)((float)(0 - (((trtcolor.red() + trtcolor.green() + trtcolor.blue())/3)) ) / 100) * -cont);
                                                }

                                                if ( trtcolor.green() < c_v )
                                                {
                                                        ac_v = ( (float)((float)(0 - trtcolor.green() ) / 100) * -cont);
                                                }
                                                else
                                                {
                                                        ac_v = ( (float)((float)(0 - (((trtcolor.red() + trtcolor.green() + trtcolor.blue())/3)) ) / 100) * -cont);
                                                }

                                                if ( trtcolor.blue() < c_b )
                                                {
                                                        ac_b = ( (float)((float)(0 - trtcolor.blue() ) / 100) * -cont);
                                                }
                                                else
                                                {
                                                        ac_b = ( (float)((float)(0 - (((trtcolor.red() + trtcolor.green() + trtcolor.blue())/3)) ) / 100) * -cont);
                                                }
                                        }
                                        else
                                        {
                                                ac_r = 0;
                                                ac_v = 0;
                                                ac_b = 0;
                                        }
                                }

                                //
                                valueadd_R = lumi + rouge + ac_r;
                                valueadd_V = lumi + vert + ac_v;
                                valueadd_B = lumi + bleu + ac_b;
                                //

                                if ( valueadd_R > 0 )
                                {
                                        if ( trtcolor.red() < 255 - valueadd_R)
                                        {
                                                trtcolor.setRed(trtcolor.red() + valueadd_R);
                                        }
                                        else
                                        {
                                                trtcolor.setRed(255);
                                        }
                                }
                                else
                                {
                                        if ( trtcolor.red() > (valueadd_R*-1))
                                        {
                                                trtcolor.setRed(trtcolor.red() + valueadd_R);
                                        }
                                        else
                                        {
                                                trtcolor.setRed(0);
                                        }
                                }

                                if ( valueadd_V > 0 )
                                {
                                        if ( trtcolor.green() < 255 - valueadd_V)
                                        {
                                                trtcolor.setGreen(trtcolor.green() + valueadd_V);
                                        }
                                        else
                                        {
                                                trtcolor.setGreen(255);
                                        }
                                }
                                else
                                {
                                        if ( trtcolor.green() > (valueadd_V*-1))
                                        {
                                                trtcolor.setGreen(trtcolor.green() + valueadd_V);
                                        }
                                        else
                                        {
                                                trtcolor.setGreen(0);
                                        }
                                }

                                if ( valueadd_B > 0 )
                                {
                                        if ( trtcolor.blue() < 255 - valueadd_B)
                                        {
                                                trtcolor.setBlue(trtcolor.blue() + valueadd_B);
                                        }
                                        else
                                        {
                                                trtcolor.setBlue(255);
                                        }
                                }
                                else
                                {
                                        if ( trtcolor.blue() > (valueadd_B*-1))
                                        {
                                                trtcolor.setBlue(trtcolor.blue() + valueadd_B);
                                        }
                                        else
                                        {
                                                trtcolor.setBlue(0);
                                        }
                                }
                                //
                                /*if ( opacity > 255 )
                                {
                                    opacity = 255;
                                }*/
                                trtcolor.setAlpha(255); //opacity);
                                wg_img_smile_effect.setPixel(x, y, trtcolor.rgba());
                        }
                }
        }
        //emit myfin();
        //exec();
}

void mainfrm::f_switch_coo_diapo()
{
    if ( frame_coorsmile->height() < 1 )
    {
        frame_coorsmile->raise();
        QPropertyAnimation *animation = new QPropertyAnimation(frame_coorsmile, "geometry");
        animation->setDuration(500);
        animation->setStartValue(QRect(frame_coorsmile->geometry().x(),frame_coorsmile->geometry().y(),frame_coorsmile->width(),frame_coorsmile->height()));
        animation->setEndValue(QRect(0,frame_coorsmile->geometry().y()-160,frame_coorsmile->width(),160));
        animation->setEasingCurve(QEasingCurve::InOutCubic);
        animation->start();
    }
    else
    {
        QPropertyAnimation *animation = new QPropertyAnimation(frame_coorsmile, "geometry");
        animation->setDuration(500);
        animation->setStartValue(QRect(frame_coorsmile->geometry().x(),frame_coorsmile->geometry().y(),frame_coorsmile->width(),frame_coorsmile->height()));
        animation->setEndValue(QRect(0,frame_coorsmile->geometry().y()+160,frame_coorsmile->width(),0));
        animation->setEasingCurve(QEasingCurve::InOutCubic);
        animation->start();
    }
}

void mainfrm::f_s_delete_position(int pos)
{
    pntmygl->f_mark_del(pos);
    //pntmygl->f_follow_timeline(screen_timeline->pos_x);
    f_display_mark_on_timeline(pntmygl->num_select);
}

void mainfrm::f_add_diapo_signal()
{
    QListWidgetItem *loc_item = new QListWidgetItem(lst_calques);

    if ( pntmygl->tab_diapo[pntmygl->nombre_diapos][0] != "NULL" && pntmygl->tab_diapo[pntmygl->nombre_diapos][0].mid(0,1) != "?" )
    {
        loc_item->setIcon(QIcon(pntmygl->tab_diapo[pntmygl->nombre_diapos][0]));
    }
    else
    {
        if ( pntmygl->tab_diapo[pntmygl->nombre_diapos][0].mid(0,1) != "?" )
        {
            loc_item->setIcon(QIcon(":/Interface/Interface/theme.png"));
        }
        else
        {
            if ( pntmygl->tab_diapo[pntmygl->nombre_diapos][0].mid(1,1) == "1" )
            {
                loc_item->setIcon(QIcon(":/Interface/Interface/cr.png"));
            }
            if ( pntmygl->tab_diapo[pntmygl->nombre_diapos][0].mid(1,1) == "2" )
            {
                loc_item->setIcon(QIcon(":/Interface/Interface/cv.png"));
            }
            if ( pntmygl->tab_diapo[pntmygl->nombre_diapos][0].mid(1,1) == "3" )
            {
                loc_item->setIcon(QIcon(":/Interface/Interface/cb.png"));
            }
            if ( pntmygl->tab_diapo[pntmygl->nombre_diapos][0].mid(1,1) == "4" )
            {
                loc_item->setIcon(QIcon(":/Interface/Interface/cw.png"));
            }
            if ( pntmygl->tab_diapo[pntmygl->nombre_diapos][0].mid(1,1) == "5" )
            {
                loc_item->setIcon(QIcon(":/Interface/Interface/snowman.png"));
            }
            if ( pntmygl->tab_diapo[pntmygl->nombre_diapos][0].mid(1,1) == "6" )
            {
                loc_item->setIcon(QIcon(":/Interface/Interface/cube.png"));
            }
            if ( pntmygl->tab_diapo[pntmygl->nombre_diapos][0].mid(1,1) == "7" )
            {
                loc_item->setIcon(QIcon(":/Interface/Interface/Earth-icon.png"));
            }
            if ( pntmygl->tab_diapo[pntmygl->nombre_diapos][0].mid(1,1) == "8" )
            {
                loc_item->setIcon(QIcon(":/Interface/Interface/plane.png"));
            }
            if ( pntmygl->tab_diapo[pntmygl->nombre_diapos][0].mid(1,1) == "9" )
            {
                loc_item->setIcon(QIcon(":/Interface/Interface/subtitle.png"));
            }
        }
    }

    loc_item->setText(tr("Image ") + " " + QString::number(pntmygl->nombre_diapos));
    loc_item->setFlags(loc_item->flags() | Qt::ItemIsUserCheckable);
    loc_item->setCheckState(Qt::Checked);

    pntmygl->tab_msk[pntmygl->nombre_diapos] = true;
}

void mainfrm::f_chk_calq(QListWidgetItem*)
{
    QList<QListWidgetItem *> selectclq = lst_calques->selectedItems();

    if ( lst_calques->selectedItems().count() < 1 )
    {
        return;
    }

    int wl_int_001 = 0;

    QListWidgetItem *clqtxt = new QListWidgetItem;
    clqtxt = selectclq.at(0);

    wl_int_001 = clqtxt->text().lastIndexOf( " " );

    if (wl_int_001 != -1)
    {
        QString wl_str_001 = clqtxt->text().mid(wl_int_001+1,clqtxt->text().length()-(wl_int_001+1));

        if ( clqtxt->checkState() == 0 )
        {
            pntmygl->tab_msk[wl_str_001.toInt()] = false;
            pntmygl->num_select = 0;
        }
        else
        {
            pntmygl->tab_msk[wl_str_001.toInt()] = true;
            pntmygl->num_select = wl_str_001.toInt();
        }

        pntmygl->updateGL();
    }
    else
    {
        qDebug() << "ERROR FINDING LAYER NUMBER";
    }
}

void mainfrm::f_s_delete_diapo(int num)
{
    lst_calques->removeItemWidget(lst_calques->item(num-1));
    lst_calques->takeItem(num-1);

    int wl_int_001 = num;
    while ( wl_int_001 < pntmygl->nombre_diapos )
    {
        pntmygl->tab_msk[wl_int_001] = pntmygl->tab_msk[wl_int_001+1];
        wl_int_001++;
    }

    f_renum_clq();
    pntmygl->updateGL();
}

void mainfrm::f_delete_image_fc(int nrow)
{
    pntmygl->num_select = nrow;
    pntmygl->f_delete_image();
}

void mainfrm::f_renum_clq()
{

    int wl_int_001 = 0;
    while ( wl_int_001 < lst_calques->count() )
    {
        lst_calques->item(wl_int_001)->setText(tr("Image ") + " " + QString::number(wl_int_001+1));
        wl_int_001++;
    }
}

void mainfrm::f_action_replace(int num)
{
        pntmygl->num_select = num;
        pntmygl->updateGL();
        pntmygl->f_swap_image();
}

void mainfrm::f_update_diapo_signal()
{
    if ( pntmygl->tab_diapo[pntmygl->num_select][0] != "NULL" )
    {
        lst_calques->item(pntmygl->num_select-1)->setIcon(QIcon(pntmygl->tab_diapo[pntmygl->num_select][0]));
        dial_smile_light->setEnabled(true);
        dial_smile_contrast->setEnabled(true);
        slider_blur_img->setEnabled(true);
    }
    else
    {
        lst_calques->item(pntmygl->num_select-1)->setIcon(QIcon(":/Interface/Interface/theme.png"));
    }
}

void mainfrm::f_select_clq(QListWidgetItem*)
{
    if ( lst_calques->selectedItems().count() < 1 )
    {
        return;
    }

    pntmygl->num_select = lst_calques->currentRow()+1;

    f_display_mark_on_timeline(pntmygl->num_select);

    pntmygl->updateGL();
}

void mainfrm::f_s_edit_image()
{
    QPixmap wl_pix_001(this->width(),this->height());
    wl_pix_001.fill(QColor(0,0,0,240));
    mask_interface->setPixmap(wl_pix_001);

    if ( wl_pix_001.load(pntmygl->tab_diapo[pntmygl->num_select][0]) == true )
    {
        smenuBar->setDisabled(true);

        mask_interface->show();
        mask_interface->raise();

        //frame_image_editor->setGeometry(10,10,this->width()-20,this->height()-40);

        if ( pntmygl->tab_diapo[pntmygl->num_select][8] == "1" )
        {
            frame_image_editor->img2resu = wl_pix_001.scaledToWidth( this->height()-50, Qt::SmoothTransformation );
            
            QMatrix matx;
            matx.rotate(-90);
            frame_image_editor->img2resu = frame_image_editor->img2resu.transformed(matx);
        }
        else
        {
            if ( pntmygl->tab_diapo[pntmygl->num_select][8] == "2" )
            {
                frame_image_editor->img2resu = wl_pix_001.scaledToWidth( this->height()-50, Qt::SmoothTransformation );
                
                QMatrix matx;
                matx.rotate(90);
                frame_image_editor->img2resu = frame_image_editor->img2resu.transformed(matx);
            }
            else
            {
                if ( wl_pix_001.width() < wl_pix_001.height() )
                {
                    frame_image_editor->img2resu = wl_pix_001.scaledToHeight( this->height()-50, Qt::SmoothTransformation );
                }
                else
                {
                    frame_image_editor->img2resu = wl_pix_001.scaledToWidth( this->width()-20, Qt::SmoothTransformation );
                }                
            }
        }

        //crop_ratio_x = (float)wl_pix_001.width()/(float)frame_image_editor->img2resu.width();
        //crop_ratio_y = (float)wl_pix_001.height()/(float)frame_image_editor->img2resu.height();

        frame_image_editor->setGeometry((this->width()-frame_image_editor->img2resu.width())/2,(this->height()-frame_image_editor->img2resu.height()-smenuBar->height())/2,frame_image_editor->img2resu.width(),frame_image_editor->img2resu.height());

        if ( pntmygl->tab_diapo[pntmygl->num_select][7] == "0/0/0/0" )
        {
            frame_image_editor->startcrop = 3;

            if ( pntmygl->tab_diapo[pntmygl->num_select][8] == "0" )
            {
                crop_ratio_x = (float)wl_pix_001.width()/(float)frame_image_editor->img2resu.width();
                crop_ratio_y = (float)wl_pix_001.height()/(float)frame_image_editor->img2resu.height();
            }
            else
            {
                crop_ratio_y = (float)wl_pix_001.width()/(float)frame_image_editor->img2resu.height();
                crop_ratio_x = (float)wl_pix_001.height()/(float)frame_image_editor->img2resu.width();
            }
        }
        else
        {
            QStringList wl_explode = pntmygl->tab_diapo[pntmygl->num_select][7].split("/",QString::KeepEmptyParts);

            if ( pntmygl->tab_diapo[pntmygl->num_select][8] == "0" )
            {
                crop_ratio_x = (float)wl_pix_001.width()/(float)frame_image_editor->img2resu.width();
                crop_ratio_y = (float)wl_pix_001.height()/(float)frame_image_editor->img2resu.height();
                
                frame_image_editor->crop_dx = wl_explode.at(0).toFloat() / crop_ratio_x;
                frame_image_editor->crop_ex = wl_explode.at(2).toFloat() / crop_ratio_x;
                frame_image_editor->crop_dy = wl_explode.at(1).toFloat() / crop_ratio_y;
                frame_image_editor->crop_ey = wl_explode.at(3).toFloat() / crop_ratio_y;
            }
            else
            {
                crop_ratio_y = (float)wl_pix_001.width()/(float)frame_image_editor->img2resu.height();
                crop_ratio_x = (float)wl_pix_001.height()/(float)frame_image_editor->img2resu.width();

                if ( pntmygl->tab_diapo[pntmygl->num_select][8] == "1" )
                {
                    frame_image_editor->crop_dy = (frame_image_editor->img2resu.height())-(wl_explode.at(0).toFloat() / crop_ratio_x);
                    frame_image_editor->crop_ey = (frame_image_editor->img2resu.height())-(wl_explode.at(2).toFloat() / crop_ratio_x);
                    frame_image_editor->crop_dx = wl_explode.at(1).toFloat() / crop_ratio_y;
                    frame_image_editor->crop_ex = wl_explode.at(3).toFloat() / crop_ratio_y;
                }
                else
                {
                    frame_image_editor->crop_dx = (frame_image_editor->img2resu.width())-(wl_explode.at(1).toFloat() / crop_ratio_y);
                    frame_image_editor->crop_ex = (frame_image_editor->img2resu.width())-(wl_explode.at(3).toFloat() / crop_ratio_y);
                    frame_image_editor->crop_dy = wl_explode.at(0).toFloat() / crop_ratio_x;
                    frame_image_editor->crop_ey = wl_explode.at(2).toFloat() / crop_ratio_x;
                }
            }

            frame_image_editor->startcrop = 4;
        }

        frame_image_editor->show();
        frame_image_editor->raise();
    }
    else
    {
        qDebug() << "ERROR LOADING PICTURE : " << pntmygl->tab_diapo[pntmygl->num_select][0] << " FOR EDITING";
    }
}

void mainfrm::f_s_cancel_image()
{
    frame_image_editor->hide();
    mask_interface->hide();
    smenuBar->setEnabled(true);
}

void mainfrm::f_s_valide_image()
{
    //qDebug() << frame_image_editor->img2resu.width() << " " << frame_image_editor->img2resu.height() << " " << crop_ratio_x << " " << crop_ratio_y << " " << frame_image_editor->crop_dx << " " << frame_image_editor->crop_ex << " " << frame_image_editor->crop_dy << " " << frame_image_editor->crop_ey;
    if ( frame_image_editor->crop_dx != 0 || frame_image_editor->crop_ex != 0 || frame_image_editor->crop_dy != 0 || frame_image_editor->crop_ey != 0)
    {
        if ( pntmygl->tab_diapo[pntmygl->num_select][8] == "0" )
        {
            pntmygl->tab_diapo[pntmygl->num_select][7] = QString::number(frame_image_editor->crop_dx*crop_ratio_x) + "/" + QString::number(frame_image_editor->crop_dy*crop_ratio_y) + "/" + QString::number(frame_image_editor->crop_ex*crop_ratio_x) + "/" + QString::number(frame_image_editor->crop_ey*crop_ratio_y);
        }
        else
        {
            QPixmap wl_pix_001;
            wl_pix_001.load(pntmygl->tab_diapo[pntmygl->num_select][0]);

            float wlx_r = (float)wl_pix_001.width()/(float)frame_image_editor->img2resu.width();
            float wly_r = (float)wl_pix_001.height()/(float)frame_image_editor->img2resu.height();

            //qDebug() << frame_image_editor->img2resu.width()*crop_ratio_x << " " << frame_image_editor->crop_dy * crop_ratio_y;
            int w_hdx;
            int w_hdy;
            int w_hex;
            int w_hey;

            //qDebug() << "CROP=" << frame_image_editor->crop_dx << " " << frame_image_editor->crop_dy << " " << frame_image_editor->crop_ex << " " << frame_image_editor->crop_ey;

            if ( pntmygl->tab_diapo[pntmygl->num_select][8] == "1" )
            {
                w_hdx = ((frame_image_editor->img2resu.width()*wlx_r)-(frame_image_editor->crop_dy*crop_ratio_y));
                w_hdy = frame_image_editor->crop_dx*crop_ratio_x;
                w_hex = ((frame_image_editor->img2resu.width()*wlx_r)-(frame_image_editor->crop_ey*crop_ratio_y));
                w_hey = frame_image_editor->crop_ex*crop_ratio_x;
            }
            else
            {
                w_hdx = frame_image_editor->crop_dy*crop_ratio_y;
                w_hdy = ((frame_image_editor->img2resu.height()*wly_r)-(frame_image_editor->crop_dx*crop_ratio_x));
                w_hex = frame_image_editor->crop_ey*crop_ratio_y;
                w_hey = ((frame_image_editor->img2resu.height()*wly_r)-(frame_image_editor->crop_ex*crop_ratio_x));
            }

            int wdx;
            int wdy;
            int wex;
            int wey;

            if ( w_hdx < w_hex )
            {
                wdx = w_hdx;
                wex = w_hex;
            }
            else
            {
                wdx = w_hex;
                wex = w_hdx;
            }

            if ( w_hdy < w_hey )
            {
                wdy = w_hdy;
                wey = w_hey;
            }
            else
            {
                wdy = w_hey;
                wey = w_hdy;
            }


            pntmygl->tab_diapo[pntmygl->num_select][7] = QString::number(wdx) + "/" + QString::number(wdy) + "/" + QString::number(wex) + "/" + QString::number(wey);
            //pntmygl->tab_diapo[pntmygl->num_select][7] = QString::number(frame_image_editor->crop_ey*crop_ratio_y) + "/" + QString::number(frame_image_editor->crop_ex*crop_ratio_x) + "/" + QString::number(frame_image_editor->crop_dy*crop_ratio_y) + "/" + QString::number(frame_image_editor->crop_dx*crop_ratio_x);
        }

        pntmygl->f_reload_img(pntmygl->num_select);
        pntmygl->updateGL();
    }

    frame_image_editor->hide();
    mask_interface->hide();
    smenuBar->setEnabled(true);
}

void mainfrm::f_bt_close_param_render()
{
    smenuBar->setEnabled(true);

    mask_interface->hide();

    frame_choose_encode->hide();
}

void mainfrm::f_bt_start_param_render()
{
    if ( (path_render_smile->text() != "" && frame_path_smile->isEnabled() == true) || frame_path_smile->isEnabled() == false )
    {
        QFile wmyficext;
        QTextStream outext(&wmyficext);

        wmyficext.setFileName(path_project + "/delall.sh");
        wmyficext.open( QIODevice::WriteOnly );
        outext << "rm -rf " + path_project + "/RDR" << endl;
        outext << "rm -f " + path_project + "/delall.sh" << endl;
        outext << "exit" << endl;
        QString programf = "bash";
        QStringList argumentsf;
        argumentsf << path_project + "/delall.sh";

        proc_ffmpeg.setProcessChannelMode(QProcess::MergedChannels);
        proc_ffmpeg.start(programf,argumentsf);

        proc_ffmpeg.waitForFinished(-1);

        if ( combo_fmt_smile->currentIndex() == 3 || combo_fmt_smile->currentIndex() == 0 || combo_fmt_smile->currentIndex() == 6  || combo_fmt_smile->currentIndex() == 7 )
        {
            wg_jpg_qual = 95;
        }
        if ( combo_fmt_smile->currentIndex() == 4 || combo_fmt_smile->currentIndex() == 1 )
        {
            wg_jpg_qual = 85;
        }
        if ( combo_fmt_smile->currentIndex() == 5 || combo_fmt_smile->currentIndex() == 2 )
        {
            wg_jpg_qual = 60;
        }

        QDir mydir(path_project);

        QDir mydir2(path_project + "/RDR");

        if ( mydir2.exists() == false )
        {

            if ( mydir.mkdir("RDR") == false )
            {
                qDebug()  << "ERROR CREATING FOLDER FOR GENERATING SLIDESHOW " << path_project + "/RDR";
                QMessageBox::information(this, name_application, tr("Erreur creation dossier generation : ") + path_project);
                return;
            }
        }

        //qDebug() << wmypro << " " << wmypro.right(4) << " " << wmypro.right(5);
        if ( combo_fmt_smile->currentIndex() < 3 || combo_fmt_smile->currentIndex() == 7 )
        {
            if ( path_render_smile->text().right(4) != ".mpg" && path_render_smile->text().right(5) != ".mpeg" && path_render_smile->text().right(4) != ".MPG" && path_render_smile->text().right(5) != ".MPEG" )
            {
                    path_render_smile->setText(path_render_smile->text() + ".mpg");
            }
        }
        else
        {
            if ( combo_fmt_smile->currentIndex() == 6 )
            {
                if ( path_render_smile->text().right(4) != ".avi" && path_render_smile->text().right(4) != ".AVI" )
                {
                        path_render_smile->setText(path_render_smile->text() + ".avi");
                }
            }
        }

        screen_timeline->num_select = 0;
        pntmygl->num_select = 0;

        frame_toolslide->setDisabled(true);
        frame_bottom_slide->setDisabled(true);
        frame_support_timeline_diapo->setDisabled(true);
        wg_str_int_001 = path_render_smile->text();

        pntmygl->wg_sav_niv_qual = pntmygl->wg_niv_qual;
        pntmygl->quality_high();

        pntmygl->f_save_diapo(num_current_diapo);
        f_load_diapo(0);
        num_current_diapo = 0;
        f_display_mark_on_timeline(0);
        player_isplaying = true;
        pntmygl->f_follow_timeline(10);
        progress_render_smile->setMaximum(pntmygl->length_diapo*25);
        pos_playing = 10;
        wg_int_001 = 0;
        sx_tr_diapo = dvdxsize;
        sy_tr_diapo = dvdysize;
        cpt_trt_trans = 0;

        isrendering = 0;
        QPixmap wl_tmp_001(sx_tr_diapo,sy_tr_diapo);
        wl_tmp_001.fill(QColor(0,0,0));

        while ( isrendering < 250 )
        {
            pntmygl->table_preview_transition[isrendering] = wl_tmp_001.toImage();
            isrendering++;
        }

        isrendering = 1;

        progress_render_smile->setValue(0);
        progress_render_smile_2->setValue(0);
        progress_render_smile_2->setMaximum(nbre_diapos);
        progress_render_smile_3->setValue(0);

        if ( frame_path_smile->isEnabled() == true )
        {
            frame_render_smile->setGeometry((this->width()-frame_render_smile->width())/2,(this->height()-211)/2,frame_render_smile->width(),211);
        }
        else
        {
            frame_render_smile->setGeometry((this->width()-frame_render_smile->width())/2,(this->height()-145)/2,frame_render_smile->width(),145);
        }

        frame_choose_encode->hide();
        frame_render_smile->show();
        frame_render_smile->raise();

        QTimer::singleShot(8, this, SLOT(f_play_diapo_boucle()));

    }
    else
    {
        QMessageBox::information(this, name_application, tr("Vous devez donner un nom et un emplacement pour la generation"));
    }
}

void mainfrm::f_bt_open_folder_render()
{
    QString wmypro = QFileDialog::getSaveFileName(this, tr("Generation du projet"), path_project, tr("Video (*.mpg *.mpeg *.MPG *.MPEG *.avi *.AVI)"));
    if ( wmypro.isNull() )
    {
        return;
    }
    else
    {
        path_render_smile->setText(wmypro);
    }
}

void mainfrm::f_combo_fmt_smile(int nump)
{
    if ( nump < 3 || nump == 6 || nump == 7 )
    {
        frame_path_smile->setEnabled(true);
    }
    else
    {
        frame_path_smile->setDisabled(true);
    }
}

void mainfrm::f_s_add_sound()
{   
    QString wmypro;
    wmypro = QFileDialog::getOpenFileName(
            this,
            tr("Charger une bande son"),
            path_save,
            "(*.wav *.WAV *.mp3 *.MP3)");

    if ( wmypro.isNull() )
    {
        return;
    }
    else
    {
        f_s_add_sound_step_2(wmypro);
    }
}

void mainfrm::f_s_add_sound_step_2(QString wmypro)
{
        if ( nbre_audio_track >= 1 )
        {
            return;
        }

        // ****************************************************
        // *** IDENTIFICATION DES CARACTERISTIQUES DU MEDIA ***
        // ****************************************************
        QFile wmyficext2;
        QTextStream outext2(&wmyficext2);

        wmyficext2.setFileName(path_project + "/extinf.sh");
        wmyficext2.open( QIODevice::WriteOnly );
        outext2 << "mplayer -identify -frames 0 -vo null -ao null \"" + wmypro + "\"" << endl;
        outext2 << "rm -f " + path_project + "/extinf.sh" << endl;
        outext2 << "exit" << endl;
        wmyficext2.close();

        wg_string_001 = "";
        QString programf = "bash";
        QStringList argumentsf;
        argumentsf <<path_project + "/extinf.sh";

        proc_ffmpeg.setProcessChannelMode(QProcess::MergedChannels);
        proc_ffmpeg.start(programf,argumentsf);

        proc_ffmpeg.waitForFinished(-1);

        int wl_intidx = wg_string_003.lastIndexOf( "ID_LENGTH=" );
        if (wl_intidx != -1)
        {
            wl_intidx = wl_intidx + 10;
            int wl_intidx2 = wl_intidx;
            QString wl_lgth_med = "";

            while ( wg_string_003.mid(wl_intidx2,1) != "." && wg_string_003.mid(wl_intidx2,1) != " " )
            {
                wl_intidx2++;
            }
            wl_lgth_med = wg_string_003.mid(wl_intidx,wl_intidx2-wl_intidx);

            audio_editor *newad = new audio_editor(timeline_diapo);

            hdl_audio = newad;
            /*newad->setGeometry(0,52,250,15);
            newad->show();*/

            newad->length_media = wl_lgth_med.toInt();
            newad->title_audio = wmypro;
            connect(newad, SIGNAL(recalc()),this, SLOT(f_recalc_length_audio()));

            nbre_audio_track = 1;
            timeline_diapo->nbre_audio_track = nbre_audio_track;

            f_recalc_length_audio();
        }
        else
        {
            QMessageBox::information(this, name_application, tr("Le media ne peut être identifie et ne sera pas utilise."));
        }
}

void mainfrm::f_s_del_sound()
{
    nbre_audio_track = 0;
    timeline_diapo->nbre_audio_track = nbre_audio_track;
    delete hdl_audio;
}

void mainfrm::f_s_adj_sound()
{
    int diap_length = (float)hdl_audio->length_media/(float)nbre_diapos;
    int wl_int_1 = 0;
    int wl_int_2 = 0;

    must_update = 0;
    spin_length_diapo->setValue(diap_length);
    screen_timeline->length_diapo = diap_length;
    pntmygl->length_diapo = diap_length;
    screen_timeline->repaint();
    must_update = 1;

    pntmygl->f_save_diapo(num_current_diapo);

    while ( wl_int_1 < nbre_diapos )
    {
        wl_int_2 = 0;
        while ( pntmygl->tab_save_diapo[wl_int_1][wl_int_2] != "$#$" )
        {
            wl_int_2++;
        }
        pntmygl->tab_save_diapo[wl_int_1][wl_int_2+1]=QString::number(diap_length);
        timeline_diapo->tab_duration[wl_int_1] = diap_length;
        wl_int_1++;
    }
    timeline_diapo->repaint();
}

void mainfrm::f_recalc_length_audio()
{
    if ( nbre_audio_track == 0 )
    {
        return;
    }
    hdl_audio->nbre_diapos = nbre_diapos;

    // *** BOUCLE CALCUL LONGUEUR ***
    int wl_int_001 = hdl_audio->position;
    int wl_ok = 0;
    int wl_cumul = 0;


    while ( wl_int_001 <= nbre_diapos && wl_ok == 0 )
    {
        wl_cumul = wl_cumul + timeline_diapo->tab_duration[wl_int_001];
        if ( wl_cumul >= hdl_audio->length_media )
        {
            wl_ok = 1;
        }
        wl_int_001++;
    }

    if ( wl_ok == 1 )
    {
        hdl_audio->setGeometry(hdl_audio->geometry().x(),66,(wl_int_001-1)*60,18);
    }
    else
    {
        hdl_audio->setGeometry(hdl_audio->geometry().x(),66,(nbre_diapos-(hdl_audio->position))*60,18);
    }

    hdl_audio->show();
}

void mainfrm::f_color_fog()
{
    if ( frame_smile->isVisible() == true )
    {
        pntmygl->fog_red = pntwheel9->red;
        pntmygl->fog_green = pntwheel9->green;
        pntmygl->fog_blue = pntwheel9->blue;

        pntmygl->f_check_fog(pntmygl->is_fog);
    }
}

void mainfrm::f_action_diapauto_fi()
{
    myfileopen *hdlfopen = new myfileopen(this);
    hdlfopen->setDirectory(pntmygl->wg_path_images);
    hdlfopen->source = 1;

    hdlfopen->setFileMode(QFileDialog::ExistingFiles);
    hdlfopen->setWindowTitle(tr("Diapositive"));
    hdlfopen->setFilter("(*.PNG *.png *.jpg *.JPG *.jeg *.JPEG)");
    connect(hdlfopen, SIGNAL(change_image(QString)),pntmygl, SLOT(f_open_ipreview(QString)));
    hdlfopen->show();
    connect(hdlfopen, SIGNAL(filesSelected( const QStringList )),this, SLOT(f_load_diapo_fi_step_2( const QStringList )));
    connect(hdlfopen, SIGNAL(f_close()),pntmygl, SLOT(f_hide_preview()));
    connect(hdlfopen, SIGNAL(finished(int)),pntmygl, SLOT(f_hide_preview()));
}

void mainfrm::f_load_diapo_fi_step_2( const QStringList wl_slmyfic )
{
    int wl_int_001 = 0;
    QString wl_myfic;
    QImage wl_pix1(50,50,QImage::Format_ARGB32_Premultiplied);
    QImage wl_img;
    QPainter p;
    int i;

    wl_myfic = wl_slmyfic.at(wl_int_001);

    i = wl_myfic.lastIndexOf( '/' );
    if ( i >= 0 )
    {
        pntmygl->wg_path_images = wl_myfic.mid(0, i);
    }

    while ( wl_int_001 < wl_slmyfic.count() )
    {
        wl_myfic = wl_slmyfic.at(wl_int_001);

        p.begin(&wl_pix1);
        p.setBrush(QColor(0,0,0));
        p.drawRect(0,0,50,50);
        p.end();

        diapos_th *newdiapo = new diapos_th(timeline_diapo);

        table_hdl_diapo[nbre_diapos] = newdiapo;

        connect(newdiapo, SIGNAL(select_diapoth(diapos_th*) ),this, SLOT(f_select_diapos_th(diapos_th*)));
        connect(newdiapo, SIGNAL(delete_diapoth(diapos_th*) ),this, SLOT(f_delete_diaposth(diapos_th*)));
        connect(newdiapo, SIGNAL(dupliquer_diapoth(diapos_th*) ),this, SLOT(f_dupliquer_diaposth(diapos_th*)));
        connect(newdiapo, SIGNAL(enter_diath(diapos_th*) ),this, SLOT(f_enter_diath(diapos_th*)));
        connect(newdiapo, SIGNAL(leave_diath(diapos_th*) ),this, SLOT(f_leave_diath(diapos_th*)));

        wl_img.load(wl_myfic);

        if ( wl_img.width() > wl_img.height() )
        {
            wl_img = wl_img.scaledToWidth(1024,Qt::SmoothTransformation);
        }
        else
        {
            wl_img = wl_img.scaledToHeight(1024,Qt::SmoothTransformation);
        }

        newdiapo->setGeometry( nbre_diapos * 60, 0, 50, 50 );
        newdiapo->draw_image = wl_img;
        newdiapo->is_edit = 0;
        newdiapo->show();

        timeline_diapo->tab_duration[nbre_diapos] = 4;
        timeline_diapo->repaint();

        int sens = pntmygl->f_load_exif(wl_myfic);

        pntmygl->tab_save_diapo[nbre_diapos][1] = wl_myfic + "$" + QString::number(wl_img.width()) + "$" + QString::number(wl_img.height()) + "$$0:0$1.0$0$0/0/0/0$" + QString::number(sens) + "$10:0.0:0.0:-3.8:0.0:0.0:0.0:1:0:0$690:0.0:0.0:-3.8:0.0:0.0:0.0:1:0:0$";
        pntmygl->tab_save_diapo[nbre_diapos][2] = "$#$";
        pntmygl->tab_save_diapo[nbre_diapos][3] = "4";
        pntmygl->tab_save_diapo[nbre_diapos][4] = "0:0:0";
        pntmygl->tab_save_diapo[nbre_diapos][5] = "";
        pntmygl->tab_save_diapo[nbre_diapos][6] = "0";
        pntmygl->tab_save_diapo[nbre_diapos][7] = "0:220:220:220";

        nbre_diapos++;
        timeline_diapo->max_diapo = nbre_diapos;
        timeline_diapo->repaint();

        if ( (nbre_diapos*70) > timeline_diapo->width() )
        {
            timeline_diapo->setGeometry(timeline_diapo->geometry().x(),0,nbre_diapos*70,timeline_diapo->height());
            scroll_timeline_smile->setMaximum(timeline_diapo->width()-frame_support_timeline->width());

            if ( myeffect_global->opacity() < 1.0 )
            {
                QPropertyAnimation *animation = new QPropertyAnimation(myeffect_global, "opacity");
                animation->setDuration(1000);
                animation->setStartValue(qreal(myeffect_global->opacity()));
                animation->setEndValue(qreal(1.0));
                animation->start();
            }
        }

        /*must_update = 0;
        pntmygl->str_trans = "";
        lst_trans_smile->setCurrentIndex(0);
        must_update = 1;

        pntmygl->nombre_diapos = 0;
        pntmygl->f_init_tabcoo();
        pntmygl->f_init_tabtex();

        pntmygl->num_select = 0;
        pntmygl->updateGL();*/

        wl_int_001++;
    }
    f_recalc_length_audio();
}

void mainfrm::f_enter_diath(diapos_th* hdlth)
{
    int wl_int_001 = 0;
    while ( table_hdl_diapo[wl_int_001] != hdlth )
    {
        wl_int_001++;
    }

    int wl_int_002 = 0;
    while ( pntmygl->tab_save_diapo[wl_int_001][wl_int_002] != "$#$" && wl_int_002 < 46 )
    {
        wl_int_002++;
    }

    if ( wl_int_002 > 45 )
    {
        return;
    }

    frame_info_slide->typeoffr = 1;
    frame_info_slide->setGeometry(hdlth->pos().x()+50,6,140,40);
    frame_info_slide->position = tr("Duree : ") + pntmygl->tab_save_diapo[wl_int_001][wl_int_002+1] + "sec \n" + QString::number(wl_int_002-1) + " " + tr("images");

    if ( pntmygl->tab_save_diapo[wl_int_001][wl_int_002+3] != "" )
    {
        QStringList wl_explode9 = pntmygl->tab_save_diapo[wl_int_001][wl_int_002+3].split("}",QString::KeepEmptyParts);
        if ( wl_explode9.at(0) != "" )
        {
            QPixmap wl_ptr(qApp->applicationDirPath()+"/Bibliotheque/Luma/" + wl_explode9.at(0));
            wl_ptr = wl_ptr.scaled(32,32);

            frame_info_slide->trans = wl_ptr;
        }
        else
        {
            QPixmap wl_ptr(":/Interface/Interface/info.png");
            wl_ptr = wl_ptr.scaled(32,32);

            frame_info_slide->trans = wl_ptr;
        }
    }
    else
    {
        QPixmap wl_ptr(":/Interface/Interface/info.png");
        wl_ptr = wl_ptr.scaled(32,32);

        frame_info_slide->trans = wl_ptr;
    }

    frame_info_slide->raise();
    frame_info_slide->letvisible();
}

void mainfrm::f_leave_diath(diapos_th*)
{
    frame_info_slide->lethidden();
}

void mainfrm::f_s_slide_lst(int value)
{
    if ( value == 1 )
    {
        if ( scroll_timeline_smile->value()+60 <= scroll_timeline_smile->maximum() )
        {
            //scroll_timeline_smile->setValue(scroll_timeline_smile->value()+4);
            QPropertyAnimation *animation = new QPropertyAnimation(scroll_timeline_smile, "value");
            animation->setDuration(300);
            animation->setStartValue(scroll_timeline_smile->value());
            animation->setEndValue(scroll_timeline_smile->value()+60);
            //animation->setEasingCurve(QEasingCurve::InOutCubic);
            animation->start();
        }
        else
        {
            QPropertyAnimation *animation = new QPropertyAnimation(scroll_timeline_smile, "value");
            animation->setDuration(300);
            animation->setStartValue(scroll_timeline_smile->value());
            animation->setEndValue(scroll_timeline_smile->maximum());
            //animation->setEasingCurve(QEasingCurve::InOutCubic);
            animation->start();

            //scroll_timeline_smile->setValue(scroll_timeline_smile->maximum());
        }
    }
    else
    {
        if ( scroll_timeline_smile->value()-60 >= 60 )
        {
            //scroll_timeline_smile->setValue(scroll_timeline_smile->value()-4);
            QPropertyAnimation *animation = new QPropertyAnimation(scroll_timeline_smile, "value");
            animation->setDuration(300);
            animation->setStartValue(scroll_timeline_smile->value());
            animation->setEndValue(scroll_timeline_smile->value()-60);
            //animation->setEasingCurve(QEasingCurve::InOutCubic);
            animation->start();

        }
        else
        {
            QPropertyAnimation *animation = new QPropertyAnimation(scroll_timeline_smile, "value");
            animation->setDuration(300);
            animation->setStartValue(scroll_timeline_smile->value());
            animation->setEndValue(0);
            //animation->setEasingCurve(QEasingCurve::InOutCubic);
            animation->start();

            //scroll_timeline_smile->setValue(0);
        }
    }
}

void mainfrm::f_color_txt_slide()
{
    if ( must_update == 1 && pntmygl->num_select > 0 )
    {
        QStringList wl_explode = pntmygl->tab_diapo[pntmygl->num_select][0].split("!;!",QString::KeepEmptyParts);
        pntmygl->tab_diapo[pntmygl->num_select][0] = "?9" + wl_explode.at(0).mid(2,wl_explode.at(0).length()) + "!;!" + QString::number(pntwheel10->red) + "*^*" + QString::number(pntwheel10->green) + "*^*" + QString::number(pntwheel10->blue) + "!;!" + wl_explode.at(2) + "!;!" + wl_explode.at(3);

        pntmygl->f_reload_text();
    }
}
