/* ============================================================
 * File  : thptradia.cpp
 * Author: Stephane Gibault
 * Date  : Sun Feb 4 2007
 * Description :
 *
 * 
 *  (C) 2007 by Stephane Gibault
 *
 * This program is free software; you can redistribute it
 * and/or modify it under the terms of the GNU General
 * Public License as published by the Free Software Foundation;
 * either version 2, or (at your option)
 * any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * ============================================================ */
#include "thptradia.h"
 
thptradia::thptradia()
{
        minx = 0;
        miny = 0;
        maxx = 0;
        maxy = 0;
}

void thptradia::run()
{
	if ( type_trans == 0 ) // *** Transitions par luma ***
	{
		if ( srcImage3.width() <= 0 || srcImage3.height() <= 0 )
		{
			return;
		}

                lumavalue = (float)((float)300/(float)100)*(float)sequence;

		if ( lumavalue >= 0 )
		{
                        mincolor = lumavalue;
		}
		else
		{
                        mincolor = lumavalue;
		}

                if ( invert == "0" )
		{
                        maxcolor = lumavalue + 40;
		}
		else
		{
                        maxcolor = lumavalue - 40;
		}

                for (y = miny; y < maxy; y++)
		{
                        for (x = minx; x < maxx; x++)
			{
                                srcPixel = srcImage.pixel(x, y);
                                srcPixel2 = srcImage2.pixel(x, y);
				srcPixel3 = srcImage3.pixel(x, y);
				tmpcolor1 = srcPixel;
				tmpcolor2 = srcPixel2;
				tmpcolor3 = srcPixel3;

				if ( invert == "0" )
				{
                                        if ( tmpcolor3.red() > mincolor )
                                        {
                                                if ( tmpcolor3.red() <= maxcolor )
                                                {
                                                        valuefade = 255-(float)((float)(tmpcolor3.value()-mincolor)*255)/(float)(maxcolor-mincolor); //(float)255+(((float)tmpcolor3.value()/(float)2.5)-((float)mycolor2.value()/(float)2.5))*(float)20;

                                                        tmpcolor3.setRed(tmpcolor1.red() * (1-(float)((float)valuefade/(float)255)) + tmpcolor2.red() * (float)((float)valuefade/(float)255));
                                                        tmpcolor3.setGreen(tmpcolor1.green() * (1-(float)((float)valuefade/(float)255)) + tmpcolor2.green() * (float)((float)valuefade/(float)255));
                                                        tmpcolor3.setBlue(tmpcolor1.blue() * (1-(float)((float)valuefade/(float)255)) + tmpcolor2.blue() * (float)((float)valuefade/(float)255));
                                                        dstPixel = tmpcolor3.rgb();
                                                        dstImage->setPixel(x, y, dstPixel);
                                                }
						else
						{
                                                        dstImage->setPixel(x, y, srcPixel);
                                                }
                                        }
					else
					{
                                                dstImage->setPixel(x, y, srcPixel2);
                                        }
				}
				else
				{
                                        if ( tmpcolor3.red() < mincolor )
                                        {
                                                if ( tmpcolor3.value() >= maxcolor )
                                                {
                                                        valuefade = 255-(float)((float)(tmpcolor3.red()-mincolor)*255)/(float)(maxcolor-mincolor); //(float)255+(((float)tmpcolor3.value()/(float)2.5)-((float)mycolor2.value()/(float)2.5))*(float)20;

                                                        tmpcolor3.setRed(tmpcolor1.red() * (1-(float)((float)valuefade/(float)255)) + tmpcolor2.red() * (float)((float)valuefade/(float)255));
                                                        tmpcolor3.setGreen(tmpcolor1.green() * (1-(float)((float)valuefade/(float)255)) + tmpcolor2.green() * (float)((float)valuefade/(float)255));
                                                        tmpcolor3.setBlue(tmpcolor1.blue() * (1-(float)((float)valuefade/(float)255)) + tmpcolor2.blue() * (float)((float)valuefade/(float)255));
                                                        dstPixel = tmpcolor3.rgb();
                                                        dstImage->setPixel(x, y, dstPixel);                                                }
						else
						{
                                                        dstImage->setPixel(x, y, srcPixel);
                                                }
                                        }
					else
					{
                                                dstImage->setPixel(x, y, srcPixel2);
                                        }
                                }
                        }
		}
	}
	else
	{
		// *** Fondu enchaine ***
		for (y = 0; y < srcImage.height(); y++)
		{
			for (x = 0; x < srcImage.width(); x++)
			{
				srcPixel = srcImage.pixel(x, y);
				srcPixel2 = srcImage2.pixel(x, y);
				tmpcolor1 = srcPixel;
				tmpcolor2 = srcPixel2;
				tmpcolor3.setRed(tmpcolor1.red() * (1-(float)((float)sequence/(float)100)) + tmpcolor2.red() * (float)((float)sequence/(float)100));
				tmpcolor3.setGreen(tmpcolor1.green() * (1-(float)((float)sequence/(float)100)) + tmpcolor2.green() * (float)((float)sequence/(float)100));
				tmpcolor3.setBlue(tmpcolor1.blue() * (1-(float)((float)sequence/(float)100)) + tmpcolor2.blue() * (float)((float)sequence/(float)100));
				dstPixel = tmpcolor3.rgb();
                                dstImage->setPixel(x, y, dstPixel);
			}				
		}
	}
        //emit myfin();
}

